<?xml version="1.0"?>
<!-- in case of any change in xsl/xml file modify all connected xsl and xml files from this package  -->

<xsl:stylesheet version="1.1" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:saxon="http://icl.com/saxon" xmlns:graph="graph" xmlns:textutil="textutil" xmlns:authors="authors" xmlns:results="results" extension-element-prefixes="saxon">


	<xsl:param name="base_font">Arial</xsl:param>
	
	<xsl:param name="header_font_size">32px</xsl:param>
	<xsl:param name="small_header_font_size">18px</xsl:param>
	<xsl:param name="base_font_size">12px</xsl:param>
	<xsl:param name="time_font_size">11px</xsl:param>
	
    <xsl:param name="authors_ignorecase">false</xsl:param>
    <xsl:param name="report_type">disk_report</xsl:param>
    <xsl:param name="report_format_mode">html</xsl:param>
    <xsl:param name="breakingThreshold">10000</xsl:param>
    <xsl:param name="breakingSize">4000</xsl:param>
    <xsl:param name="test_params"></xsl:param>
    <xsl:param name="test_config_name"></xsl:param>
    <xsl:param name="test_config_origin"></xsl:param>
    <xsl:param name="RES_BACK_TO_TOP"> </xsl:param>
    <xsl:param name="RES_PARAMETER_TEST"> </xsl:param>
    <xsl:param name="RES_TASKS_BY_AUTHOR"> </xsl:param>
    <xsl:param name="RES_PARAMETER_UNKNOWN"> </xsl:param>
    <xsl:param name="RES_PARAMETER_NO_RESOURCES_FOUND"> </xsl:param>
    <xsl:param name="RES_PARAMETER_REPORT"> </xsl:param>
    <xsl:param name="RES_PARAMETER_RUN_TIME"> </xsl:param>
	<xsl:param name="RES_PARAMETER_TCM_REPORT"> </xsl:param>
    <xsl:param name="RES_PARAMETER_TCM_MANAGER_REPORT"> </xsl:param>
    <xsl:param name="RES_PARAMETER_THROWS_EXCEPTION"> </xsl:param>
    <xsl:param name="RES_PARAMETER_VIOLATION_POINT"> </xsl:param>
    <xsl:param name="RES_PARAMETER_VIOLATION_CAUSE"> </xsl:param>
    <xsl:param name="RES_PARAMETER_BUG_DETECTIVE_LEGEND"> </xsl:param>
    <xsl:param name="RES_PARAMETER_CRITICAL_DATA_FLOW"> </xsl:param>
    <xsl:param name="RES_PARAMETER_ACCOMPLISH_ALL_TASKS"> </xsl:param>
    <xsl:param name="RES_PARAMETER_DONT_PERFORM_TASKS"> </xsl:param>    
    <xsl:param name="RES_PARAMETER_ACCOMPLISH_ALL"> </xsl:param>
    <xsl:param name="RES_PARAMETER_DONT_PERFORM"> </xsl:param>    
    <xsl:param name="RES_PARAMETER_GOAL_NO_MORE_THAN"> </xsl:param>
    <xsl:param name="RES_PARAMETER_GOAL_BY"> </xsl:param>
    <xsl:param name="RES_PARAMETER_GOAL_NO"> </xsl:param>    
    <xsl:param name="RES_PARAMETER_GOAL_CS_VIOLATIONS"> </xsl:param>
    <xsl:param name="RES_PARAMETER_DELTA_TOTAL"> </xsl:param>
    <xsl:param name="RES_PARAMETER_GOAL"> </xsl:param>
    <xsl:param name="RES_PARAMETER_TOTAL_LOWERCASE"> </xsl:param>
    <xsl:param name="RES_PARAMETER_ERROR"> </xsl:param>
    <xsl:param name="RES_PARAMETER_INVALID_SYMBOLS_DURING_ESTIMATION"> </xsl:param>
    <xsl:param name="RES_PARAMETER_NOT_SUPPORTED_SYMBOLS_DURING_ESTIMATION"> </xsl:param>
    <xsl:param name="RES_PARAMETER_LEGEND"> </xsl:param>
    <xsl:param name="RES_PARAMETER_CONTEXT"> </xsl:param>
    <xsl:param name="RES_PARAMETER_NO_ESTIMABLE_CONTEXT"> </xsl:param>
    <xsl:param name="RES_PARAMETER_TEST_EXECUTION_LOWERCASE"> </xsl:param>
    <xsl:param name="RES_PARAMETER_TEST_GENERATION_LOWERCASE"> </xsl:param>
    <xsl:param name="RES_PARAMETER_CODING_STANDARDS_LOWERCASE"> </xsl:param>
    <xsl:param name="RES_PARAMETER_FUNCTIONAL_TESTS_LOWERCASE"> </xsl:param>
    <xsl:param name="RES_PARAMETER_CHANGE_IMPACTS_LOWERCASE"> </xsl:param>
    <xsl:param name="RES_PARAMETER_BUILD_ERRORS"> </xsl:param>
    <xsl:param name="RES_PARAMETER_GOALS"> </xsl:param>
    <xsl:param name="RES_PARAMETER_GOAL_NAME"> </xsl:param>    
    <xsl:param name="RES_PARAMETER_METRICS"> </xsl:param>
    <xsl:param name="RES_PARAMETER_CODEREVIEW"> </xsl:param>
    <xsl:param name="RES_PARAMETER_CREATED_REVIEWS"> </xsl:param>
    <xsl:param name="RES_PARAMETER_NEW_REVIEWS"> </xsl:param>
    <xsl:param name="RES_PARAMETER_PENDING_REVIEWS"> </xsl:param>
    <xsl:param name="RES_PARAMETER_PENDING_ISSUES"> </xsl:param>
    <xsl:param name="RES_PARAMETER_MONITOR_REVIEWS"> </xsl:param>
    <xsl:param name="RES_PARAMETER_UNDEFINED_AUTHORS"> </xsl:param>
    <xsl:param name="RES_PARAMETER_UNMATCHED_PATHS"> </xsl:param>
    <xsl:param name="RES_PARAMETER_CR_CREATED"> </xsl:param>
    <xsl:param name="RES_PARAMETER_CR_NEW"> </xsl:param>
    <xsl:param name="RES_PARAMETER_CR_PENDING_REVIEWS"> </xsl:param>
    <xsl:param name="RES_PARAMETER_CR_PENDING_ISSUES"> </xsl:param>
    <xsl:param name="RES_PARAMETER_CR_MONITORED"> </xsl:param>
    <xsl:param name="RES_PARAMETER_CODING_STANDARDS"> </xsl:param>    
    <xsl:param name="RES_PARAMETER_SUPPRESSIONS"> </xsl:param>
    <xsl:param name="RES_PARAMETER_PUSH_BUTTON_INFO"> </xsl:param>
    <xsl:param name="RES_PARAMETER_REASON"> </xsl:param>
    <xsl:param name="RES_PARAMETER_OS"> </xsl:param>
    <xsl:param name="RES_PARAMETER_REPORTIMNG_SYSTEM"> </xsl:param>
    <xsl:param name="RES_PARAMETER_PARASOFT"> </xsl:param>
    <xsl:param name="RES_PARAMETER_COVERAGE"> </xsl:param>
    <xsl:param name="RES_PARAMETER_NO_TEST_CASES_GENERATED"> </xsl:param>
    <xsl:param name="RES_PARAMETER_TEST_CASES_PER_AUTHOR"> </xsl:param>
    <xsl:param name="RES_PARAMETER_NEW_TEST_CASES"> </xsl:param>
    <xsl:param name="RES_PARAMETER_TEST_FILES"> </xsl:param>
    <xsl:param name="RES_PARAMETER_CHECKED_FILES"> </xsl:param>
    <xsl:param name="RES_PARAMETER_SUPPRESSED"> </xsl:param>
    <xsl:param name="RES_PARAMETER_FAILURE"> </xsl:param>
    <xsl:param name="RES_PARAMETER_EXCEPTION"> </xsl:param>
    <xsl:param name="RES_PARAMETER_DATE"> </xsl:param>
    <xsl:param name="RES_PARAMETER_NOT_AVAILABLE"> </xsl:param>
    <xsl:param name="RES_PARAMETER_RESOURCES"> </xsl:param>
    <xsl:param name="RES_PARAMETER_SYMBOLS"> </xsl:param>
    <xsl:param name="RES_PARAMETER_BY"> </xsl:param>
    <xsl:param name="RES_PARAMETER_COVERAGE_SUMMARY"> </xsl:param>
    <xsl:param name="RES_PARAMETER_DETAILED_COVERAGE_REPORT"> </xsl:param>
    <xsl:param name="RES_PARAMETER_STANDARDS_TESTED_FILES_DETAILS"> </xsl:param>
    <xsl:param name="RES_PARAMETER_EXECUTED_TESTS_DETAILS"> </xsl:param>
    <xsl:param name="RES_PARAMETER_EXPAND_ALL"> </xsl:param>
    <xsl:param name="RES_PARAMETER_COLLAPSE_ALL"> </xsl:param>
    <xsl:param name="RES_PARAMETER_TOTAL_TASKS"> </xsl:param>
    <xsl:param name="RES_PARAMETER_TOTAL_CHANGES"> </xsl:param>
    <xsl:param name="RES_PARAMETER_RECOMMENDED_TASKS_TO_ACCOMPLISH"> </xsl:param>
    <xsl:param name="RES_PARAMETER_IMPUTS_OUTPUTS"> </xsl:param>
    <xsl:param name="RES_PARAMETER_VERIFIED_BY"> </xsl:param>
    <xsl:param name="RES_PARAMETER_TEST_CASE"> </xsl:param> 
    <xsl:param name="RES_PARAMETER_TEST_CASES_LOWERCASE"> </xsl:param>    
    <xsl:param name="RES_PARAMETER_TEST_CASE_LOWERCASE"> </xsl:param>
    <xsl:param name="RES_PARAMETER_CAUSED_BY"> </xsl:param>
    <xsl:param name="RES_PARAMETER_RECOMMENDED"> </xsl:param>    
    <xsl:param name="RES_PARAMETER_RECOMMENDED_TASKS"> </xsl:param>
    <xsl:param name="RES_PARAMETER_TOTAL_RECOMMENDED_NO_INITIAL_SLASH"> </xsl:param>    
    <xsl:param name="RES_PARAMETER_AUTHOR"> </xsl:param>
    <xsl:param name="RES_PARAMETER_TEST_GENERATION"> </xsl:param>
    <xsl:param name="RES_PARAMETER_TEST_EXECUTION"> </xsl:param>
    <xsl:param name="RES_PARAMETER_PROJECT_NAME"> </xsl:param>
    <xsl:param name="RES_PARAMETER_TASKS"> </xsl:param>
    <xsl:param name="RES_PARAMETER_CHANGES"> </xsl:param>
    <xsl:param name="RES_PARAMETER_TASKS_LOWERCASE"> </xsl:param>
    <xsl:param name="RES_PARAMETER_TASK_LOWERCASE"> </xsl:param>          
    <xsl:param name="RES_PARAMETER_SUPP"> </xsl:param>
    <xsl:param name="RES_PARAMETER_PER"> </xsl:param>    
    <xsl:param name="RES_PARAMETER_FILES"> </xsl:param>    
    <xsl:param name="RES_PARAMETER_CHECKED"> </xsl:param>
    <xsl:param name="RES_PARAMETER_LINES"> </xsl:param>
    <xsl:param name="RES_PARAMETER_TOTAL"> </xsl:param>    
    <xsl:param name="RES_PARAMETER_SEVERITY"> </xsl:param>
    <xsl:param name="RES_PARAMETER_SEVERITY_1"> </xsl:param>
    <xsl:param name="RES_PARAMETER_SEVERITY_2"> </xsl:param>
    <xsl:param name="RES_PARAMETER_SEVERITY_3"> </xsl:param>
    <xsl:param name="RES_PARAMETER_SEVERITY_4"> </xsl:param>
    <xsl:param name="RES_PARAMETER_SEVERITY_5"> </xsl:param>
    <xsl:param name="RES_PARAMETER_CATEGORY"> </xsl:param>
    <xsl:param name="RES_PARAMETER_QFIX"> </xsl:param>
    <xsl:param name="RES_PARAMETER_LONG_DESCRIPTION1"> </xsl:param>
    <xsl:param name="RES_PARAMETER_PERCENTAGE"> </xsl:param>
    <xsl:param name="RES_PARAMETER_TESTED"> </xsl:param>
    <xsl:param name="RES_PARAMETER_TESTS"> </xsl:param>
    <xsl:param name="RES_PARAMETER_CLASSES"> </xsl:param>
    <xsl:param name="RES_PARAMETER_TEST_CASES"> </xsl:param>
    <xsl:param name="RES_PARAMETER_EXECUTED"> </xsl:param>
    <xsl:param name="RES_PARAMETER_PASSED_TEST_CASES"> </xsl:param>
    <xsl:param name="RES_PARAMETER_FAILED_TEST_CASES"> </xsl:param>
    <xsl:param name="RES_PARAMETER_ERROR_TEST_CASES"> </xsl:param>
    <xsl:param name="RES_PARAMETER_PASSED_TEST_CASES_LOWERCASE"> </xsl:param>
    <xsl:param name="RES_PARAMETER_FAILED_TEST_CASES_LOWERCASE"> </xsl:param>
    <xsl:param name="RES_PARAMETER_ERROR_TEST_CASES_LOWERCASE"> </xsl:param>
    <xsl:param name="RES_PARAMETER_TOTAL_TEST_CASES"> </xsl:param>
    <xsl:param name="RES_PARAMETER_METHODS"> </xsl:param>
    <xsl:param name="RES_PARAMETER_BY_CATEGORY"> </xsl:param>
    <xsl:param name="RES_PARAMETER_BY_SEVERITY"> </xsl:param>
    <xsl:param name="RES_PARAMETER_DISTRIBUTION_TOTAL"> </xsl:param>
    <xsl:param name="RES_PARAMETER_DISTRIBUTION_RECOMMENDED"> </xsl:param>
    <xsl:param name="RES_PARAMETER_TEST_PROJECT_NAME"> </xsl:param>
    <xsl:param name="RES_PARAMETER_EXECUTED_TEST_CASES"> </xsl:param>
    <xsl:param name="RES_PARAMETER_REVIEW_UNIT_TEST_OUTCOMES"> </xsl:param>
    <xsl:param name="RES_PARAMETER_TEST_PROJECT_NAME_DESC"> </xsl:param>
    <xsl:param name="RES_PARAMETER_FUNCTIONAL_TESTS"> </xsl:param>
    <xsl:param name="RES_PARAMETER_PROVISIONING_ACTIONS"> </xsl:param>
    <xsl:param name="RES_PARAMETER_CHANGE_IMPACT"> </xsl:param>
    <xsl:param name="RES_PARAMETER_TEST_SUITE_SUMMARY"> </xsl:param>
    <xsl:param name="RES_PARAMETER_ACTION_SUITE_SUMMARY"> </xsl:param>
    <xsl:param name="RES_PARAMETER_ASSET_SUMMARY"> </xsl:param>
    <xsl:param name="RES_PARAMETER_NAME"> </xsl:param>
    <xsl:param name="RES_PARAMETER_IMPACTED"> </xsl:param>
    <xsl:param name="RES_PARAMETER_ERRORS"> </xsl:param>
    <xsl:param name="RES_PARAMETER_FAILED_TESTS"> </xsl:param>
    <xsl:param name="RES_PARAMETER_CHANGED_TESTS"> </xsl:param>
    <xsl:param name="RES_PARAMETER_SUCCESSFUL_TESTS"> </xsl:param>
    <xsl:param name="RES_PARAMETER_UNCHANGED_TESTS"> </xsl:param>
    <xsl:param name="RES_PARAMETER_TOTAL_TESTS"> </xsl:param>
    <xsl:param name="RES_PARAMETER_TOTAL_ASSETS"> </xsl:param>
    <xsl:param name="RES_PARAMETER_SUCCESS_PERCENT"> </xsl:param>
    <xsl:param name="RES_PARAMETER_IMPACT_PERCENT"> </xsl:param>
    <xsl:param name="RES_PARAMETER_NAME2"> </xsl:param>
    <xsl:param name="RES_PARAMETER_SUCCEEDED"> </xsl:param>
    <xsl:param name="RES_PARAMETER_DETAILED_ERROR_MESSAGE"> </xsl:param>
    <xsl:param name="RES_PARAMETER_DETAILED_ERROR_MESSAGE_LOWERCASE"> </xsl:param>
    <xsl:param name="RES_PARAMETER_MESSAGE"> </xsl:param>
    <xsl:param name="RES_PARAMETER_TRAFFIC_LOG"> </xsl:param>
    <xsl:param name="RES_PARAMETER_REQUEST"> </xsl:param>
    <xsl:param name="RES_PARAMETER_RESPONSE"> </xsl:param>
    <xsl:param name="RES_PARAMETER_EXECUTION_TIME"> </xsl:param>
    <xsl:param name="RES_PARAMETER_TRAFFIC_VIEWER"> </xsl:param>
    <xsl:param name="RES_PARAMETER_VIEW_TRAFFIC"> </xsl:param>
    <xsl:param name="RES_PARAMETER_TEST_TRAFFIC"> </xsl:param>
    <xsl:param name="RES_PARAMETER_RESULT_NA"> </xsl:param>
    <xsl:param name="RES_PARAMETER_MEMORY_LEAK_SUMMARY"> </xsl:param>
    <xsl:param name="RES_ALLOCATION_STACK_TRACE"> </xsl:param>
    <xsl:param name="RES_DEALLOCATION_STACK_TRACE"> </xsl:param>
    <xsl:param name="RES_PARAMETER_RESULTS_FROM"> </xsl:param>
    <xsl:param name="RES_PARAMETER_ACTIVE_RULES"> </xsl:param>
    <xsl:param name="RES_PARAMETER_ELLIPSIS"> </xsl:param>
    <xsl:param name="RES_NO_METRICS"> </xsl:param>
    <xsl:param name="RES_PARAMETER_REVISION"> </xsl:param>
    <xsl:param name="RES_PARAMETER_COMMENT"> </xsl:param>
    <xsl:param name="RES_PARAMETER_SCREENSHOT_VIEWER"> </xsl:param>
    <xsl:param name="RES_PARAMETER_SCREENSHOTS"> </xsl:param>
    
    <xsl:param name="COV_API_COVERAGE"> </xsl:param>
    <xsl:param name="COV_COVERABLE_RESOURCE"> </xsl:param>
    <xsl:param name="COV_COVERAGE_LOWER"> </xsl:param>
    <xsl:param name="COV_SUCCESS_TOTAL"> </xsl:param>
    
    <xsl:param name="output_dir"/>    
    <xsl:param name="send_links_only_mode"></xsl:param>    
    <xsl:variable name="links">links</xsl:variable>
    <xsl:variable name="trends">trends</xsl:variable>
    
    <xsl:param name="rules_dir_path"/>
    <xsl:param name="suppr_msgs">false</xsl:param>
    <xsl:param name="dev_errors">false</xsl:param>
    <xsl:param name="dev_reports">true</xsl:param>
    <xsl:param name="show_active_rules">false</xsl:param>
    <xsl:param name="generate_graphs">true</xsl:param>
    <xsl:param name="associations">false</xsl:param>
    <xsl:param name="test_cases_details">false</xsl:param>
    <xsl:param name="process_quick_fixes">true</xsl:param>
    <xsl:param name="dev_reports_prefix"></xsl:param>
    <xsl:param name="exec_cvg_details">false</xsl:param>
    <xsl:param name="attachments">false</xsl:param>
    <xsl:param name="cvg_html"></xsl:param>
    <xsl:param name="test_suites_only">true</xsl:param>
    <xsl:param name="failed_tests_only">false</xsl:param>
    <xsl:param name="report.setup.problems">top</xsl:param>
    <xsl:param name="authors_details">true</xsl:param>
    <xsl:param name="contexts_details">false</xsl:param>

    <xsl:param name="header_img"/>
    <xsl:param name="header_exp_img"/>
    <xsl:param name="header_logo_img"/>
    <xsl:param name="footer_img"/>
    <xsl:param name="footer_exp_img"/>            
    <xsl:variable name="disk_report">disk_report</xsl:variable> 
    <xsl:variable name="tcm_report">tcm_report</xsl:variable>   
    <xsl:variable name="email_report">email_report</xsl:variable>
    <xsl:variable name="nbsp" select="concat('&amp;','nbsp;')" saxon:assignable="yes"/>
    <xsl:variable name="copy" select="concat('&amp;','copy;')" saxon:assignable="yes"/>    
    <xsl:variable name="reg" select="concat('&amp;','reg;')"/>
    <xsl:variable name="qt">"</xsl:variable>
    <xsl:param name="width">100%</xsl:param>
    <xsl:param name="authors_width">75%</xsl:param>
    <xsl:variable name="cs_bcolor">#F3F3F3</xsl:variable>
    <xsl:variable name="cs_bdrcolor">#CBCBCB</xsl:variable>
    <xsl:variable name="func_bcolor">#F3F3F3</xsl:variable>
    <xsl:variable name="func_bdrcolor">#CBCBCB</xsl:variable>
    <xsl:variable name="exec_bcolor">#F3F3F3</xsl:variable>
    <xsl:variable name="exec_bdrcolor">#CBCBCB</xsl:variable>    
    <xsl:variable name="berr_bcolor">#F3F3F3</xsl:variable>
    <xsl:variable name="berr_bdrcolor">#CBCBCB</xsl:variable>
    <xsl:variable name="cr_bcolor">#F3F3F3</xsl:variable>
    <xsl:variable name="cr_bdrcolor">#CBCBCB</xsl:variable>
    <xsl:variable name="goals_bcolor">#F3F3F3</xsl:variable>
    <xsl:variable name="goals_bdrcolor">#CBCBCB</xsl:variable>
    <xsl:variable name="statistics_bcolor">#F3F3F3</xsl:variable>
    <xsl:variable name="statistics_bdrcolor">#CBCBCB</xsl:variable>             
    <xsl:variable name="blueborder_color">#A0CAEC</xsl:variable>
    <xsl:variable name="body_color">#E7F0F5</xsl:variable>
    <xsl:variable name="footer_color">#1D488D</xsl:variable>

	<xsl:variable name="headerblue_color">#3965A6</xsl:variable>
    <xsl:variable name="red_color">#990000</xsl:variable>
    <xsl:variable name="goldenrod_color">#DAA520</xsl:variable>
    <xsl:variable name="blue_color">#000099</xsl:variable>
    <xsl:variable name="green_color">#008040</xsl:variable>
    
    <xsl:variable name="metrics_pdf_columns">7</xsl:variable>

    <xsl:variable name="styles">
    BODY,P,OL,TD,pre{font-family: <xsl:value-of select="$base_font"/>, Helvetica, sans-serif;font-size: <xsl:value-of select="$base_font_size"/>;font-style: normal;color: #000000;}
    A:link {font-family: <xsl:value-of select="$base_font"/>, Helvetica, sans-serif;font-style: normal;color: #990000;text-decoration: none;}
    A:active {font-family: <xsl:value-of select="$base_font"/>, Helvetica, sans-serif;font-style: normal;color: #990000;text-decoration: none;}
    A:visited {font-family: <xsl:value-of select="$base_font"/>, Helvetica, sans-serif;font-style: normal;color: #999999;text-decoration: none;}
    A:hover {font-family: <xsl:value-of select="$base_font"/>, Helvetica, sans-serif;font-style: normal;color: #990000;text-decoration: underline;}
    A.gray_link:link {font-family: <xsl:value-of select="$base_font"/>;font-size: <xsl:value-of select="$base_font_size"/>;color: #666666;text-decoration: none;}
    A.gray_link:active {font-family: <xsl:value-of select="$base_font"/>;font-size: <xsl:value-of select="$base_font_size"/>;color: #666666;text-decoration: none;}
    A.gray_link:visited {font-family: <xsl:value-of select="$base_font"/>;font-size: <xsl:value-of select="$base_font_size"/>;color: #666666;text-decoration: none;}
    A.gray_link:hover {font-family: <xsl:value-of select="$base_font"/>;font-size: <xsl:value-of select="$base_font_size"/>;color: #666666;text-decoration: underline;}
    A.red_link:link {font-family: <xsl:value-of select="$base_font"/>;font-size: <xsl:value-of select="$base_font_size"/>;color: #990000;text-decoration: none;}
    A.red_link:active {font-family: <xsl:value-of select="$base_font"/>;font-size: <xsl:value-of select="$base_font_size"/>;color: #990000;text-decoration: none;}
    A.red_link:visited {font-family: <xsl:value-of select="$base_font"/>;font-size: <xsl:value-of select="$base_font_size"/>;color: #990000;text-decoration: none;}
    A.red_link:hover {font-family: <xsl:value-of select="$base_font"/>;font-size: <xsl:value-of select="$base_font_size"/>;color: #990000;text-decoration: underline;}
    A.green_link:link {font-family: <xsl:value-of select="$base_font"/>;font-size: <xsl:value-of select="$base_font_size"/>;color: #008040;text-decoration: none;}
    A.green_link:active {font-family: <xsl:value-of select="$base_font"/>;font-size: <xsl:value-of select="$base_font_size"/>;color: #008040;text-decoration: none;}
    A.green_link:visited {font-family: <xsl:value-of select="$base_font"/>;font-size: <xsl:value-of select="$base_font_size"/>;color: #008040;text-decoration: none;}
    A.green_link:hover {font-family: <xsl:value-of select="$base_font"/>;font-size: <xsl:value-of select="$base_font_size"/>;color: #008040;text-decoration: underline;}
    A.black_link:link {font-family: <xsl:value-of select="$base_font"/>;font-size: <xsl:value-of select="$base_font_size"/>;color: #000000;text-decoration: none;}
    A.black_link:active {font-family: <xsl:value-of select="$base_font"/>;font-size: <xsl:value-of select="$base_font_size"/>;color: #000000;text-decoration: none;}
    A.black_link:visited {font-family: <xsl:value-of select="$base_font"/>;font-size: <xsl:value-of select="$base_font_size"/>;color: #000000;text-decoration: none;}
    A.black_link:hover {font-family: <xsl:value-of select="$base_font"/>;font-size: <xsl:value-of select="$base_font_size"/>;color: #000000;text-decoration: underline;}
    
    A.blue_link:link {font-family: Arial;font-size: <xsl:value-of select="$base_font_size"/>;color: #427fb6;text-decoration: none;}
    A.blue_link:active {font-family: Arial;font-size: <xsl:value-of select="$base_font_size"/>;color: #427fb6;text-decoration: none;}
    A.blue_link:visited {font-family: Arial;font-size: <xsl:value-of select="$base_font_size"/>;color: #427fb6;text-decoration: none;}
    A.blue_link:hover {font-family: Arial;font-size: <xsl:value-of select="$base_font_size"/>;color: #427fb6;text-decoration: underline;}
    
    A.gray_red_link:link {font-family: <xsl:value-of select="$base_font"/>;font-size: <xsl:value-of select="$base_font_size"/>;color: #666666;text-decoration: none;}
    A.gray_red_link:active {font-family: <xsl:value-of select="$base_font"/>;font-size: <xsl:value-of select="$base_font_size"/>;color: #666666;text-decoration: none;}
    A.gray_red_link:visited {font-family: <xsl:value-of select="$base_font"/>;font-size: <xsl:value-of select="$base_font_size"/>;color: #666666;text-decoration: none;}
    A.gray_red_link:hover {font-family: <xsl:value-of select="$base_font"/>;font-size: <xsl:value-of select="$base_font_size"/>;color: #666666;text-decoration: none;}
    DIV.suite_details{margin-left: 40px; padding: 10px; border: 2px solid #99aaaa;}
    DIV.test_comment{color:#666666;}
    DIV.header{font-size: <xsl:value-of select="$header_font_size"/>; FONT-FAMILY: <xsl:value-of select="$base_font"/>, Helvetica, sans-serif; COLOR: #427fb6 }
    DIV.small_header{font-size: <xsl:value-of select="$small_header_font_size"/>; FONT-FAMILY: <xsl:value-of select="$base_font"/>, Helvetica, sans-serif; COLOR: #427fb6 }    
    FONT.gray {font-size: <xsl:value-of select="$base_font_size"/>;font-family: <xsl:value-of select="$base_font"/>, Helvetica, sans-serif;color: #999999;}    
    FONT.gray2, FONT.gray_red {font-size: <xsl:value-of select="$base_font_size"/>;font-family: <xsl:value-of select="$base_font"/>, Helvetica, sans-serif;color: #666666;}
    FONT.white {font-size: <xsl:value-of select="$base_font_size"/>;font-family: <xsl:value-of select="$base_font"/>, Helvetica, sans-serif;color: #FFFFFF;}
    FONT.time {font-size: <xsl:value-of select="$time_font_size"/>;font-family: <xsl:value-of select="$base_font"/>, Helvetica, sans-serif;color: #000000;}
    FONT.black {font-family: <xsl:value-of select="$base_font"/>, Helvetica, sans-serif;font-size: <xsl:value-of select="$base_font_size"/>;font-style: normal;color: #000000;}
    FONT.red {font-size: <xsl:value-of select="$base_font_size"/>;font-family: <xsl:value-of select="$base_font"/>, Helvetica, sans-serif;color: #990000;}
    FONT.red2 {font-size: <xsl:value-of select="$base_font_size"/>;font-family: <xsl:value-of select="$base_font"/>, Helvetica, sans-serif;color: #990000; text-decoration: underline;}
    FONT.blue {font-size: <xsl:value-of select="$base_font_size"/>;font-family: <xsl:value-of select="$base_font"/>, Helvetica, sans-serif;color: #427fb6;}
    FONT.green {font-size: <xsl:value-of select="$base_font_size"/>;font-family: <xsl:value-of select="$base_font"/>, Helvetica, sans-serif;color: #008040;}
    FONT.orange {font-size: <xsl:value-of select="$base_font_size"/>;font-family: <xsl:value-of select="$base_font"/>, Helvetica, sans-serif;color: #F69500;}
    FONT.goldenrod {font-size: <xsl:value-of select="$base_font_size"/>;font-family: <xsl:value-of select="$base_font"/>, Helvetica, sans-serif;color: #DAA520;}    
    FONT.small {font-size: 3px;font-family: <xsl:value-of select="$base_font"/>, Helvetica, sans-serif;color: #cccccc;}
    IMG.screenshot{float:left; margin-right: 20px; border:1px solid black;}
    SELECT.cs_authors {font-family: <xsl:value-of select="$base_font"/>, Helvetica, sans-serif;font-size: <xsl:value-of select="$base_font_size"/>;}  
    SELECT.ju_authors {font-family: <xsl:value-of select="$base_font"/>, Helvetica, sans-serif;font-size: <xsl:value-of select="$base_font_size"/>;}  
    SPAN.toggle_button{width: 16px; padding-right: 2px; display: inline-block;} 
    TD.associations{vertical-align: top;}
    TD.collapse_controls{text-align:right;}
    TD.cs_authors{font-family: <xsl:value-of select="$base_font"/>, Helvetica, sans-serif;font-size: <xsl:value-of select="$base_font_size"/>;font-style: normal;color: #000000;border: 1px; bordercolor: #d9c8ac;}
    TD.error{background-color:#ffeeee}
    TD.errorsingleborder{background-color:#ffeeee;border:1px solid <xsl:value-of select="$cs_bdrcolor"/>}
    TD.singleborder{ border:1px solid <xsl:value-of select="$cs_bdrcolor"/>}
    TABLE.header{background-color:#FFFFFF}
    TABLE.singleborder{ border:1px solid <xsl:value-of select="$cs_bdrcolor"/>}
    TABLE.doubleborder{ border:2px solid <xsl:value-of select="$cs_bdrcolor"/>}     
    TABLE.singleborder_blue{ border:2px solid #427fb6}
    TD.fixed_width{width: 150px;}
    TD.no_error{}
    TD.suite_details{padding:2px; }
    UL.metrics {font-family: <xsl:value-of select="$base_font"/>, Helvetica, sans-serif;font-size: <xsl:value-of select="$base_font_size"/>;font-style: normal;color: #000000; list-style-type: none; margin: 0; padding-left:12px;}
    UL.root {font-family: <xsl:value-of select="$base_font"/>, Helvetica, sans-serif;font-size: <xsl:value-of select="$base_font_size"/>;font-style: normal;color: #000000; list-style-type: none; margin: 0; padding-left:0px; margin-left:3px;}
    UL {font-family: <xsl:value-of select="$base_font"/>, Helvetica, sans-serif;font-size: <xsl:value-of select="$base_font_size"/>;font-style: normal;color: #000000; list-style-type: none; margin: 0; padding-left:0px; margin-left:12px;}
    LI {font-family: <xsl:value-of select="$base_font"/>, Helvetica, sans-serif;font-size: <xsl:value-of select="$base_font_size"/>;font-style: normal;color: #000000; list-style-type: none; margin: 0; padding-left: 0px;}
    #foldheader{cursor:pointer;cursor:hand ;}
    #cs_foldheader{cursor:pointer;cursor:hand ;}
    #cr_foldheader{cursor:pointer;cursor:hand ;}
    #metrics_foldheader{cursor:pointer;cursor:hand ;}
    #exec_foldheader{cursor:pointer;cursor:hand ;}
    #paramsHeader {word-break:break-all;overflow: auto; padding: 3px;}
    </xsl:variable>
    
    <xsl:variable name="styles_pdf">   	
   		<PDF_STYLE attr="div" name="header" font-size="18pt" font-family="Arial" color="#427fb6"/>
    	<PDF_STYLE attr="div" name="small_header" font-size="11pt" font-family="Arial" color="#427fb6"/>
    	<PDF_STYLE attr="div" name="white" font-size="$base_font_size" font-family="Arial" color="#FFFFFF"/>
    	<PDF_STYLE attr="font" name="black" font-size="$base_font_size" font-family="Arial" color="#000000"/>
    	<PDF_STYLE attr="font" name="red" font-size="$base_font_size" font-family="Arial" color="#990000"/>
    	<PDF_STYLE attr="font" name="gray" font-size="$base_font_size" font-family="Arial" color="#999999"/>
    	<PDF_STYLE attr="font" name="green" font-size="$base_font_size" font-family="Arial" color="#008040"/>
    	<PDF_STYLE attr="font" name="goldenrod" font-size="$base_font_size" font-family="Arial" color="#DAA520"/>
    	<PDF_STYLE attr="font" name="blue" font-size="$base_font_size" font-family="Arial" color="#427fb6"/>
    	<PDF_STYLE attr="font" name="orange" font-size="$base_font_size" font-family="Arial" color="#F69500"/>
    	<PDF_STYLE attr="font" name="small" font-size="3px" font-family="Arial" color="#cccccc"/>
    	<PDF_STYLE attr="table" name="doubleborder" border="1"/> 
    	<PDF_STYLE attr="table" name="singleborder" border="1"/>   
    	<PDF_STYLE attr="td" name="singleborder" border="1"/>
    	<PDF_STYLE attr="td" name="errorsingleborder" border="1"/>
    	<PDF_STYLE attr="table" name="singleborder_blue" border="1"/>
    </xsl:variable>
    
    <xsl:variable name="openWin">
    var nwin;    
    function openWin (loc_to_open) {    
       if (!nwin || nwin.closed) {
          nwin = window.open(loc_to_open,'');
       } else {
          nwin.location = loc_to_open;
       }
       nwin.focus();
    }
    function openDevReport (dev_rep_name) {
       openWin(dev_rep_name);
    }
    </xsl:variable> 
    
    <xsl:variable name="init">
    <xsl:if test="($report_format_mode='html')">
    if(document.getElementById("cs_link_sev") != null) {
    document.getElementById("cs_link_sev").style.color="#990000";
    document.getElementById("cs_link_sev").style.textDecoration="underline";
    }
    if(document.getElementById("cs_link_sevtrue") != null) {
    document.getElementById("cs_link_sevtrue").style.color="#990000";
    document.getElementById("cs_link_sevtrue").style.textDecoration="underline";
    }
    </xsl:if>
    </xsl:variable> 

    <xsl:variable name="displayTree">
    var ns6=document.getElementById &amp;&amp; !document.all
    var ie4=document.all &amp;&amp; navigator.userAgent.indexOf("Opera")==-1

    function checkcontained(e)
    {
       cur=ns6 ? e.target : event.srcElement;
       
       checkFor("foldinglist", "foldheader", cur);
       checkFor("cs_foldinglist", "cs_foldheader", cur);
       checkFor("cr_foldinglist", "cr_foldheader", cur);
       checkFor("metrics_foldinglist", "metrics_foldheader", cur);
       checkFor("exec_foldinglist", "exec_foldheader", cur);
    }
    
    function checkFor(foldinglist, foldheader, cur)
    {
        var iscontained=0;
        i = 0;
        if (cur.id==foldheader) {
           iscontained=1;
        } 
        while (ns6 &amp;&amp; cur.parentNode || (ie4 &amp;&amp; cur.parentElement)) {
             if (cur.id==foldheader||cur.id==foldinglist){
                iscontained=(cur.id==foldheader)? 1 : 0;
                break;
             }
             cur=ns6? cur.parentNode : cur.parentElement;
        }

        if (iscontained) {
           var foldercontent=ns6? cur.nextSibling.nextSibling : cur['nextSibling'];
           if (foldercontent.style.display=="none"){
               foldercontent.style.display="";
           } else {
               foldercontent.style.display="none";
           }
        }    
    }
    function expandCSDetails() {
       expandCollapseAll("cs_foldinglist", true);
    }

    function collapseCSDetails() {
       expandCollapseAll("cs_foldinglist", false);
    }
    
    function expandCRDetails() {
    expandCollapseAll("cr_foldinglist", true);
    }
    
    function collapseCRDetails() {
    expandCollapseAll("cr_foldinglist", false);
    }
    
    function expandMetricsDetails() {
    expandCollapseAll("metrics_foldinglist", true);
    }
    
    function collapseMetricsDetails() {
    expandCollapseAll("metrics_foldinglist", false);
    }
    
    function expandExecDetails() {
       expandCollapseAll("exec_foldinglist", true);
    }

    function collapseExecDetails() {
       expandCollapseAll("exec_foldinglist", false);
    }
    
    function expandCollapseAll(foldinglistID, collapse) 
    {
        if (document.getElementById &amp;&amp; document.createElement) {
            m = document.getElementById(foldinglistID).getElementsByTagName('ul');
            var i;
            for (i = 0; i &lt; m.length; i++) {
              if (collapse) {
                 m[i].style.display='block';
              } else {
                 m[i].style.display='none';
              }
            }
        }
    }

    if (ie4||ns6) {
       document.onclick=checkcontained;
    }
    </xsl:variable>
    
    <xsl:variable name="sortCodingStandards">
    function sortBySeverity(urgent){
    if(urgent != null)  {
        sev=document.getElementById("cs_sevtrue");
        sev_link=document.getElementById("cs_link_sevtrue");
        sev_title=document.getElementById("cs_title_sevtrue");
    } else {
        sev=document.getElementById("cs_sev");
        sev_link=document.getElementById("cs_link_sev");
        sev_title=document.getElementById("cs_title_sev");
    }   
    if(sev != null) sev.style.display='block';
    if(sev_title != null) sev_title.style.display='block';
    if(sev_link != null) {
    sev_link.style.color="#666666";  
    sev_link.style.textDecoration="none";
    }
    if(urgent != null)  {
        cat=document.getElementById("cs_cattrue");
        cat_link=document.getElementById("cs_link_cattrue");
        cat_title=document.getElementById("cs_title_cattrue");
    } else {
        cat=document.getElementById("cs_cat");
        cat_link=document.getElementById("cs_link_cat");
        cat_title=document.getElementById("cs_title_cat");
    }   
    if(cat != null) cat.style.display='none';
    if(cat_title != null) cat_title.style.display='none';
    if(cat_link != null) {
    cat_link.style.color="#990000";
    cat_link.style.textDecoration="underline";
    }
    }
    
    function sortByCategory(urgent){
    if(urgent != null)  {
        sev=document.getElementById("cs_sevtrue");
        sev_link=document.getElementById("cs_link_sevtrue");
        sev_title=document.getElementById("cs_title_sevtrue");
    } else {
        sev=document.getElementById("cs_sev");
        sev_link=document.getElementById("cs_link_sev");
        sev_title=document.getElementById("cs_title_sev");
    }
    if(sev != null) sev.style.display='none';
    if(sev_title != null) sev_title.style.display='none';
    if(sev_link != null) { 
    sev_link.style.color="#990000";   
    sev_link.style.textDecoration="underline";
    }       
    if(urgent != null)  {
        cat=document.getElementById("cs_cattrue");
        cat_link=document.getElementById("cs_link_cattrue");
        cat_title=document.getElementById("cs_title_cattrue");
    } else {
        cat=document.getElementById("cs_cat");
        cat_link=document.getElementById("cs_link_cat");
        cat_title=document.getElementById("cs_title_cat");
    }
    if(cat != null) cat.style.display='block';
    if(cat_title != null) cat_title.style.display='block';
    if(cat_link != null) { 
    cat_link.style.color="#666666"; 
    cat_link.style.textDecoration="none";
    }
    }
    </xsl:variable>

	<xsl:variable name="encoded_header_logo_img">
       <xsl:call-template name="encoded_image_ref">
          <xsl:with-param name="src" select="($header_logo_img)"/>
          <xsl:with-param name="alt" select="($header_logo_img)"/>
       </xsl:call-template>
    </xsl:variable>
	<xsl:variable name="encoded_header_img">
       <xsl:call-template name="encoded_image_ref">
          <xsl:with-param name="src" select="($header_img)"/>
          <xsl:with-param name="alt" select="($header_img)"/>
       </xsl:call-template>
    </xsl:variable>
	<xsl:variable name="encoded_header_exp_background">
       <xsl:call-template name="encoded_background">
          <xsl:with-param name="src" select="($header_exp_img)"/>
          <xsl:with-param name="alt" select="($header_exp_img)"/>
       </xsl:call-template>
    </xsl:variable>
    
	<xsl:variable name="generateHeader">
		function generateHeader() {			
        	var header=&#34;&lt;table xmlns:textutil=&#39;textutil&#39; xmlns:authors=&#39;authors&#39; width=&#39;100%&#39; cellpadding=&#39;0&#39; cellspacing=&#39;0&#39;>&lt;tr>&lt;td bgcolor=&#39;#3965A6&#39; &#34;+<xsl:value-of select='($encoded_header_exp_background)'/>+&#34; width=&#39;30%&#39; align=&#39;left&#39;>&#34;+<xsl:value-of select='($encoded_header_logo_img)'/>+&#34;&lt;/td>&lt;td bgcolor=&#39;#3965A6&#39;  &#34;+<xsl:value-of select='($encoded_header_exp_background)'/>+&#34;  height=&#39;80px&#39; width=&#39;40%&#39; align=&#39;center&#39;>&#34;+<xsl:value-of select='($encoded_header_img)'/>+&#34;&lt;/td>&lt;td bgcolor=&#39;#3965A6&#39;  &#34;+<xsl:value-of select='($encoded_header_exp_background)'/>+&#34;  height=&#39;80px&#39; width=&#39;30%&#39; align=&#39;center&#39;>&lt;/td>&lt;/tr>&lt;/table>&#34;;        	
        	return header;
    	}
	</xsl:variable>
    
    <xsl:variable name="showTrafficLogWithIterations">
    function showTrafficLogWithIterations(testId, iterationCount, time) {
        var doc = window.open(&#34;&#34;,&#34;_blank&#34;,&#34;&#34;); 
        var optionsArray = new Array();
        var execTime = document.getElementById("executionTimeIterationId1_" + testId).value;
        var request = document.getElementById("requestIterationId1_" + testId).value;
        var response = document.getElementById("responseIterationId1_" + testId).value;
        for (var i = 0; i &lt; iterationCount; i++) {
            var option = (i+1);
            optionsArray.push(option);
        }
        
        doc.document.write(
            &#34;&lt;!DOCTYPE html PUBLIC &#39;-//W3C//DTD XHTML 1.0 Transitional//EN&#39; &#39;http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd&#39;&gt;&#34;+
            &#34;&lt;html xmlns=&#39;http://www.w3.org/1999/xhtml&#39;&gt;&#34;+
            &#34;&lt;head&gt;&#34;+
            &#34;&lt;title&gt;<xsl:value-of select='$RES_PARAMETER_TRAFFIC_VIEWER' />&lt;/title&gt;&#34;+
            &#34;&lt;style type=&#39;text/css&#39;&gt;&#34;+
	    &#34;&lt;!--&#34;+
	    &#34;BODY,P,OL,TD,pre{font-family: <xsl:value-of select="$base_font"/>, Helvetica, sans-serif;font-size: <xsl:value-of select="$base_font_size"/>;font-style: normal;color: #000000;}&#34;+
	    &#34;DIV.header{font-size: 32px; FONT-FAMILY: Arial, Helvetica, sans-serif; COLOR: #427fb6 }&#34;+
	    &#34;DIV.small_header{font-size: <xsl:value-of select="$small_header_font_size"/>; FONT-FAMILY: <xsl:value-of select="$base_font"/>, Helvetica, sans-serif; COLOR: #427fb6 }&#34;+
	    &#34;FONT.time {font-size: <xsl:value-of select="$time_font_size"/>;font-family: <xsl:value-of select="$base_font"/>, Helvetica, sans-serif;color: #000000; padding-left:10px;}&#34;+
	    &#34;FONT.white {font-size: <xsl:value-of select="$base_font_size"/>;font-family: <xsl:value-of select="$base_font"/>, Helvetica, sans-serif;color: #FFFFFF;}&#34;+
	    &#34;.textArea {width:100%; height: 235px;  resize: none; border-style: none; border-color: Transparent; outline: none; padding:0px; overflow:auto;}&#34;+
	    &#34;TD.singleborder{ border:1px solid #CBCBCB}&#34;+
	    &#34;TD.doubleborder{ border:2px solid #CBCBCB}&#34;+
	    &#34;TABLE.header{background-color:#FFFFFF}&#34;+
	    &#34;TABLE.singleborder_blue{ border:2px solid #427fb6; height: 500px; padding-left:25px; padding-right:25px; padding-bottom:25px; padding-top:5px;}&#34;+
	    &#34;TABLE.singleborder{ border:1px solid #CBCBCB}&#34;+
	    &#34;TABLE.doubleborder{ border:2px solid #CBCBCB}&#34;+
            &#34;body {background-color: #E7F0F5;}&#34;+
            &#34;.messageHeader {width:100%; background-color:#ccdddd; border: solid 1px #99aaaa; text-align:center;}&#34;+
            &#34;#executionTime {width:95%; text-align:left; padding:10px;}&#34;+
            &#34;--&gt;&#34;+
            &#34;&lt;/style&gt;&#34; + 
            &#34;&lt;script type=&#39;text/javascript&#39; language=&#39;javascript&#39;&gt;&#34; +
            &#34;function setTrafficText(iterationId, execTimeStr) {&#34; +
            &#34;var testId = document.getElementById(&#39;testId&#39;).value;&#34; +
            &#34;var eTime = &#39;executionTimeIterationId&#39;;&#34; +
            &#34;var req = &#39;requestIterationId&#39;;&#34; +
            &#34;var resp = &#39;responseIterationId&#39;;&#34; +
            &#34;eTime = eTime.concat(iterationId + &#39;_&#39; + testId);&#34; + 
            &#34;req = req.concat(iterationId + &#39;_&#39; + testId);&#34; + <!-- requestIterationId2_wk:///testing/testing.tst#0000000000#0000000001#0000000002 -->
            &#34;resp = resp.concat(iterationId + &#39;_&#39; + testId);&#34; + <!-- responseIterationId2_wk:///testing/testing.tst#0000000000#0000000001#0000000002 -->
            &#34;var execTime = document.getElementById(eTime).value;&#34; +
            &#34;var execTimeString = execTimeStr + &#39;: &lt;strong&gt;&#39; + execTime + &#39;ms&lt;/strong&gt;&#39;;&#34; +
            &#34;document.getElementById(&#39;executionTime&#39;).innerHTML = execTimeString;&#34; +
            &#34;var request = document.getElementById(req).value;&#34; +
            &#34;document.getElementById(&#39;requestMessage&#39;).value = request;&#34; +
            &#34;var response = document.getElementById(resp).value;&#34; +
            &#34;document.getElementById(&#39;responseMessage&#39;).value = response&#34; +
            &#34;}&#34; +
            &#34;&lt;\/script&gt;&#34;+
            &#34;&lt;/head&gt;&#34;+
            &#34;&lt;body&gt;&#34;+
	    generateHeader() +
            &#34;&lt;table width=&#39;100%&#39; cellspacing=&#39;0&#39;&gt;&#34;+
            &#34;&lt;tr&gt;&#34;+
            &#34;&lt;td style=&#39;padding:5px&#39; align=&#39;center&#39;&gt;&#34;+
            &#34;&lt;font class=&#39;time&#39;&gt;&#34;+time+&#34;&lt;/font&gt;&#34;+
            &#34;&lt;/td&gt;&#34;+
            &#34;&lt;/tr&gt;&#34;+
            &#34;&lt;tr&gt;&#34;+
            &#34;&lt;td align=&#39;center&#39;&gt;&#34;+
            &#34;&lt;table align=&#39;center&#39; width=&#39;95%&#39; class=&#39;singleborder_blue&#39; cellpadding=&#39;0&#39; cellspacing=&#39;0&#39; bgcolor=&#39;#FFFFFF&#39;&gt;&#34;+
            &#34;&lt;tr&gt;&lt;td align=&#39;center&#39; valign=&#39;top&#39;&gt;&#34;+
            &#34;&lt;table border=&#39;0&#39; cellpadding=&#39;0&#39; cellspacing=&#39;0&#39; bordercolor=&#39;#99aaaa&#39;&gt;&#34;+
	    &#34;&lt;tr&gt;&#34;+
	    &#34;&lt;td&gt;&lt;div class=&#39;header&#39; align=&#39;center&#39;&gt;<xsl:value-of select='$RES_PARAMETER_TRAFFIC_LOG'/>&lt;/div&gt;&lt;/td&gt;&#34;+
            &#34;&lt;/tr&gt;&#34;+
	    &#34;&lt;/table&gt;&#34;+
	    &#34;&lt;table width=&#39;95%&#39; cellspacing=&#39;0&#39; cellpadding=&#39;0&#39;&gt;&#34;);
            if (iterationCount > 1) {
                doc.document.write(&#34;&lt;tr&gt;&#34;+
                &#34;&lt;td align=&#39;left&#39; &gt;&#34;+
                &#34;&lt;select align=&#39;left&#39; name=&#39;IterationCombo&#39; size=&#39;1&#39; onChange=&#39;javascript:setTrafficText(this.options[this.selectedIndex].value, &amp;#39;<xsl:value-of select='$RES_PARAMETER_EXECUTION_TIME'/>&amp;#39;);&#39;&gt;&#34;);
                for (var i = 0; i &lt; iterationCount; i++) {
                    var iterationOption = optionsArray[i];
                    doc.document.write(&#34;&lt;option value=&#39;&#34;+iterationOption+&#34;&#39;&gt;Row #&#34;+(i+1)+&#34;&lt;/option&gt;&#34;);
                }
                doc.document.write(&#34;&lt;/select&gt;&#34;+
                &#34;&lt;/td&gt;&#34;+
                &#34;&lt;/tr&gt;&#34;);
            }
	    doc.document.write(&#34;&lt;tr&gt;&#34;+
	    &#34;&lt;td align=&#39;center&#39;&gt;&#34;+
	    &#34;&lt;div class=&#39;small_header&#39;&gt;<xsl:value-of select='$RES_PARAMETER_REQUEST'/>&lt;/div&gt;&lt;/td&gt;&#34;+
            &#34;&lt;/tr&gt;&#34;+
	    &#34;&lt;tr&gt;&#34;+
            &#34;&lt;td class=&#39;doubleborder&#39; align=&#39;center&#39;&gt;&lt;textarea class=&#39;textArea&#39; name=&#39;requestMessage&#39; id=&#39;requestMessage&#39; rows=&#39;16&#39; readOnly&gt;&#34;+request+&#34;&lt;/textarea&gt;&lt;/td&gt;&#34;+
            &#34;&lt;/tr&gt;&#34;+
            &#34;&lt;/table&gt;&#34;+
            &#34;&lt;br /&gt;&#34;+
            &#34;&lt;table width=&#39;95%&#39; cellspacing=&#39;0&#39; cellpadding=&#39;0&#39;&gt;&#34;+
	    &#34;&lt;tr&gt;&#34;+
	    &#34;&lt;td align=&#39;center&#39;&gt;&#34;+
            &#34;&lt;div class=&#39;small_header&#39;&gt;<xsl:value-of select='$RES_PARAMETER_RESPONSE'/>&lt;/div&gt;&lt;/td&gt;&#34;+
	    &#34;&lt;/tr&gt;&#34;+
	    &#34;&lt;tr&gt;&#34;+
	    &#34;&lt;td align=&#39;left&#39;&gt;&#34;+
            &#34;&lt;div id=&#39;executionTime&#39;&gt;<xsl:value-of select='$RES_PARAMETER_EXECUTION_TIME'/>: &lt;strong&gt;&#34;+execTime+&#34;ms&lt;/strong&gt;&lt;/div&gt;&#34;+
	    &#34;&lt;/td&gt;&#34;+
	    &#34;&lt;/tr&gt;&#34;+
            &#34;&lt;tr&gt;&#34;+	    
	    &#34;&lt;td class=&#39;doubleborder&#39; align=&#39;center&#39;&gt;&lt;textarea class=&#39;textArea&#39; name=&#39;responseMessage&#39; id=&#39;responseMessage&#39; rows=&#39;16&#39; readOnly&gt;&#34;+response+&#34;&lt;/textarea&gt;&lt;/td&gt;&#34;+
	    &#34;&lt;/tr&gt;&#34;+
	    &#34;&lt;/table&gt;&#34;+
            &#34;&lt;/td&gt;&#34;+
	    &#34;&lt;/tr&gt;&#34;+
	    &#34;&lt;/table&gt;&#34;+
            &#34;&lt;/td&gt;&#34;+
	    &#34;&lt;/tr&gt;&#34;+	    
            &#34;&lt;/table&gt;&#34;+
            &#34;&lt;br /&gt;&#34;+
            &#34;&lt;table align=&#39;center&#39; width=&#39;100%&#39; bgcolor=&#39;#1D488D&#39; cellpadding=&#39;10&#39; cellspacing=&#39;0&#39;&gt;&#34;+
            &#34;&lt;tr&gt;&#34;+
            &#34;&lt;td align=&#39;center&#39;&gt;&lt;font class=&#39;white&#39;&gt;&amp;#xA9;<xsl:value-of select='$RES_PARAMETER_PARASOFT'/>&amp;#xA0;<xsl:value-of select='($toolName)'/>&amp;#xA0;<xsl:value-of select='($toolVer)'/>&amp;#xA0;<xsl:value-of select='$RES_PARAMETER_REPORTIMNG_SYSTEM'/>&amp;#xA0;&lt;/font&gt;&lt;/td&gt;&#34;+
            &#34;&lt;/tr&gt;&#34;+
            &#34;&lt;/table&gt;&#34;);
            
            doc.document.write("&lt;input type='hidden' id='");
            doc.document.write("testId");
            doc.document.write("' value='" + testId + "'/&gt;");
            for (var i = 0; i &lt; iterationCount; i++) {
                doc.document.write("&lt;input type='hidden' id='");
                var reqid = "executionTimeIterationId" + (i+1) + "_" + testId;
                doc.document.write(reqid);
                doc.document.write("' value='" + document.getElementById(reqid).value + "'/&gt;");
                
                doc.document.write("&lt;input type='hidden' id='");
                var reqid = "requestIterationId" + (i+1) + "_" + testId;
                doc.document.write(reqid);
                var regExp = RegExp("'", "g") <!-- The "g" causes it to match all instances of the specified character rather than just the first. -->
                var reqString = document.getElementById(reqid).value.replace(regExp, "&amp;#39;");
                doc.document.write("' value='" + reqString + "'/&gt;");
                
                doc.document.write("&lt;input type='hidden' id='");
                var respid = "responseIterationId" + (i+1) + "_" + testId;
                doc.document.write(respid);
                var respString = document.getElementById(respid).value.replace(regExp, "&amp;#39;");
                doc.document.write("' value='" +  respString + "'/&gt;");
            }
            doc.document.write(&#34;&lt;/body&gt;&#34;+
            &#34;&lt;/html&gt;&#34;);
            doc.document.close();
    }
    </xsl:variable>
    
    <xsl:variable name="showTrafficLog">
    function showTrafficLog(reqHeaderId, reqBodyId, respHeaderId, respBodyId, time, requestTime, responseTime) {
        var doc = window.open(&#34;&#34;,&#34;_blank&#34;,&#34;&#34;);
        var requestHeader = document.getElementById(reqHeaderId).value;
        var requestBody = document.getElementById(reqBodyId).value;
        var responseHeader = document.getElementById(respHeaderId).value;
        var responseBody = document.getElementById(respBodyId).value;
        var execTime = -1;
        try {
            execTime = responseTime - requestTime; 
        } catch (e) {
        }
        if (execTime &lt; 1) {
            execTime = "&lt;1";
        }
        var request = "";
        var response = "";
        if (requestHeader != null &amp;&amp; requestHeader.length > 0) {
            request = requestHeader + "\r\n\r\n";
        }
        if (responseHeader != null &amp;&amp; responseHeader.length > 0) {
            response = responseHeader + "\r\n\r\n";
        }
        request += requestBody;
        response += responseBody;
        doc.document.write(
            &#34;&lt;!DOCTYPE html PUBLIC &#39;-//W3C//DTD XHTML 1.0 Transitional//EN&#39; &#39;http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd&#39;&gt;&#34;+
            &#34;&lt;html xmlns=&#39;http://www.w3.org/1999/xhtml&#39;&gt;&#34;+
            &#34;&lt;head&gt;&#34;+
            &#34;&lt;title&gt;<xsl:value-of select='$RES_PARAMETER_TRAFFIC_VIEWER' />&lt;/title&gt;&#34;+
            &#34;&lt;style type=&#39;text/css&#39;&gt;&#34;+
	    &#34;&lt;!--&#34;+
	    &#34;BODY,P,OL,TD,pre{font-family: <xsl:value-of select="$base_font"/>, Helvetica, sans-serif;font-size: <xsl:value-of select="$base_font_size"/>;font-style: normal;color: #000000;}&#34;+
    	    &#34;DIV.header{font-size: 32px; FONT-FAMILY: Arial, Helvetica, sans-serif; COLOR: #427fb6 }&#34;+
	    &#34;DIV.small_header{font-size: <xsl:value-of select="$small_header_font_size"/>; FONT-FAMILY: <xsl:value-of select="$base_font"/>, Helvetica, sans-serif; COLOR: #427fb6 }&#34;+
	    &#34;FONT.time {font-size: <xsl:value-of select="$time_font_size"/>;font-family: <xsl:value-of select="$base_font"/>, Helvetica, sans-serif;color: #000000; padding-left:10px;}&#34;+
	    &#34;FONT.white {font-size: <xsl:value-of select="$base_font_size"/>;font-family: <xsl:value-of select="$base_font"/>, Helvetica, sans-serif;color: #FFFFFF;}&#34;+
	    &#34;TD.singleborder{ border:1px solid #CBCBCB}&#34;+
	    &#34;.textArea {width:100%; height: 235px;  resize: none; border-style: none; border-color: Transparent; outline: none; padding:0px; overflow:auto;}&#34;+
	    &#34;TD.doubleborder{ border:2px solid #CBCBCB}&#34;+
	    &#34;TABLE.header{background-color:#FFFFFF}&#34;+
	    &#34;TABLE.singleborder_blue{ border:2px solid #427fb6; height: 500px; padding-left:25px; padding-right:25px; padding-bottom:25px; padding-top:5px;}&#34;+
	    &#34;TABLE.singleborder{ border:1px solid #CBCBCB}&#34;+
	    &#34;TABLE.doubleborder{ border:2px solid #CBCBCB}&#34;+
            &#34;body {background-color: #E7F0F5;}&#34;+
            &#34;#detailedMessage {width:100%; height: 235px; border: solid 1px #99aaaa; padding:0px;}&#34;+
            &#34;.messageHeader {width:100%; background-color:#ccdddd; border: solid 1px #99aaaa; text-align:center;}&#34;+
            &#34;#executionTime {width:95%; text-align:left; padding:10px;}&#34;+
            &#34;--&gt;&#34;+
            &#34;&lt;/style&gt;&lt;/head&gt;&#34;+
	    &#34;&lt;body&gt;&#34;+

            generateHeader() +
            &#34;&lt;table width=&#39;100%&#39; cellspacing=&#39;0&#39;&gt;&#34;+
            &#34;&lt;tr&gt;&#34;+
            &#34;&lt;td style=&#39;padding:5px&#39; align=&#39;center&#39;&gt;&#34;+
            &#34;&lt;font class=&#39;time&#39;&gt;&#34;+time+&#34;&lt;/font&gt;&#34;+
            &#34;&lt;/td&gt;&#34;+
            &#34;&lt;/tr&gt;&#34;+
            &#34;&lt;tr&gt;&#34;+
            &#34;&lt;td align=&#39;center&#39;&gt;&#34;+
            &#34;&lt;table align=&#39;center&#39; width=&#39;95%&#39; class=&#39;singleborder_blue&#39; cellpadding=&#39;0&#39; cellspacing=&#39;0&#39; bgcolor=&#39;#FFFFFF&#39;&gt;&#34;+
            &#34;&lt;tr&gt;&lt;td align=&#39;center&#39; valign=&#39;top&#39;&gt;&#34;+
            &#34;&lt;table border=&#39;0&#39; cellpadding=&#39;0&#39; cellspacing=&#39;0&#39; bordercolor=&#39;#99aaaa&#39;&gt;&#34;+
	    &#34;&lt;tr&gt;&#34;+
	    &#34;&lt;td&gt;&lt;div class=&#39;header&#39; align=&#39;center&#39;&gt;<xsl:value-of select='$RES_PARAMETER_TRAFFIC_LOG'/>&lt;/div&gt;&lt;/td&gt;&#34;+
            &#34;&lt;/tr&gt;&#34;+
            &#34;&lt;/table&gt;&#34;+
	    &#34;&lt;table width=&#39;95%&#39; cellspacing=&#39;0&#39; cellpadding=&#39;0&#39;&gt;&#34;+
	    &#34;&lt;tr&gt;&#34;+
	    &#34;&lt;td align=&#39;center&#39;&gt;&#34;+
	    &#34;&lt;div class=&#39;small_header&#39;&gt;<xsl:value-of select='$RES_PARAMETER_REQUEST'/>&lt;/div&gt;&lt;/td&gt;&#34;+
            &#34;&lt;/tr&gt;&#34;+
	    &#34;&lt;tr&gt;&#34;+
            &#34;&lt;td class=&#39;doubleborder&#39; align=&#39;left&#39;&gt;&lt;textarea class=&#39;textArea&#39; &gt;&#34;+request+&#34;&lt;/textarea&gt;&lt;/td&gt;&#34;+
            &#34;&lt;/tr&gt;&#34;+
            &#34;&lt;/table&gt;&#34;+
	    &#34;&lt;br /&gt;&#34;+
            &#34;&lt;table width=&#39;95%&#39; cellspacing=&#39;0&#39; cellpadding=&#39;0&#39;&gt;&#34;+
	    &#34;&lt;tr&gt;&#34;+
	    &#34;&lt;td align=&#39;center&#39;&gt;&#34;+
            &#34;&lt;div class=&#39;small_header&#39;&gt;<xsl:value-of select='$RES_PARAMETER_RESPONSE'/>&lt;/div&gt;&lt;/td&gt;&#34;+
	    &#34;&lt;/tr&gt;&#34;+
	    &#34;&lt;tr&gt;&#34;+
	    &#34;&lt;td align=&#39;left&#39;&gt;&#34;+
            &#34;&lt;div id=&#39;executionTime&#39;&gt;<xsl:value-of select='$RES_PARAMETER_EXECUTION_TIME'/>: &lt;strong&gt;&#34;+execTime+&#34;ms&lt;/strong&gt;&lt;/div&gt;&#34;+
	    &#34;&lt;/td&gt;&#34;+
	    &#34;&lt;/tr&gt;&#34;+
            &#34;&lt;tr&gt;&#34;+
            &#34;&lt;td class=&#39;doubleborder&#39; align=&#39;left&#39;&gt;&lt;textarea class=&#39;textArea&#39; &gt;&#34;+response+&#34;&lt;/textarea&gt;&lt;/td&gt;&#34;+
	    &#34;&lt;/tr&gt;&#34;+
	    &#34;&lt;/table&gt;&#34;+
            &#34;&lt;/td&gt;&#34;+
	    &#34;&lt;/tr&gt;&#34;+
	    &#34;&lt;/table&gt;&#34;+
            &#34;&lt;/td&gt;&#34;+
	    &#34;&lt;/tr&gt;&#34;+	    
            &#34;&lt;/table&gt;&#34;+
	    &#34;&lt;br /&gt;&#34;+
            &#34;&lt;table align=&#39;center&#39; width=&#39;100%&#39; bgcolor=&#39;#1D488D&#39; cellpadding=&#39;10&#39; cellspacing=&#39;0&#39;&gt;&#34;+
	    &#34;&lt;tr&gt;&#34;+
            &#34;&lt;td align=&#39;center&#39;&gt;&lt;font class=&#39;white&#39;&gt;&amp;#xA9;<xsl:value-of select='$RES_PARAMETER_PARASOFT'/>&amp;#xA0;<xsl:value-of select='($toolName)'/>&amp;#xA0;<xsl:value-of select='($toolVer)'/>&amp;#xA0;<xsl:value-of select='$RES_PARAMETER_REPORTIMNG_SYSTEM'/>&amp;#xA0;&lt;/font&gt;&lt;/td&gt;&#34;+
            &#34;&lt;/tr&gt;&#34;+
            &#34;&lt;/table&gt;&#34;+
            &#34;&lt;/body&gt;&#34;+
            &#34;&lt;/html&gt;&#34;);
            doc.document.close();
    }
    </xsl:variable>
    
    <xsl:variable name="toggleTestDetails">
    function toggleTestDetails(id, toggleElement) {
        if (document.getElementById) {
            var collapse = document.getElementById(id);
            if (collapse.style.display == 'none') {
                toggleElement.innerHTML = "[-]"
                collapse.style.display = '';
            } else {
                toggleElement.innerHTML = "[+]"
                collapse.style.display = 'none';
            }
        }
    }
    
    function expandCollapseAllDetails(expand) {
        if (document.getElementsByTagName) {
            var spanList = document.getElementsByTagName('span');
            for (var i = 0; i &lt; spanList.length; i++) {
                var span = spanList[i];
                if (span.className &amp;&amp; span.className == "toggle_button") {
                    if (expand) {
                        span.innerHTML = "[-]"; 
                    } else {
                        span.innerHTML = "[+]";
                    }
                }
            }
            var trList = document.getElementsByTagName('tr');
            for(var i = 0; i &lt; trList.length; i++) {
                var tr = trList[i];
                if (tr.className &amp;&amp; tr.className == "details_container") {
                    if (expand) {
                        tr.style.display = '';
                    } else {
                        tr.style.display = 'none';
                    }
                }
            }
        }
    }
    
    function popupScreenshot(imageSrc) {
        var win = window.open("","_blank","");
        win.document.write("&lt;html&gt;&lt;head&gt;&lt;title&gt;<xsl:value-of select='$RES_PARAMETER_SCREENSHOT_VIEWER'/>&lt;/title&gt;"
        + "&lt;style&gt;"
        + "body {background-color: #E7F0F5;}"
        + "body, p, ol, td, pre { color: black; font-family: <xsl:value-of select="$base_font"/>,Helvetica,sans-serif; font-size: <xsl:value-of select="$base_font_size"/>; font-style: normal;}"
        + "FONT.white {font-size: <xsl:value-of select="$base_font_size"/>;font-family: <xsl:value-of select="$base_font"/>, Helvetica, sans-serif;color: #FFFFFF;}"
        + "TABLE.singleborder_blue{ border:2px solid #427fb6; height: 500px; padding-left:25px; padding-right:25px; padding-bottom:25px; padding-top:5px;}"
        + "IMG.screenshot {border:1px solid black;}"
        + "TD.header {font-weight:bold; border: 1px solid #99aaaa; text-align: center; width: 100%; background-color: #ccdddd;}"
        + "&lt;/style&gt;"
        + "&lt;/head&gt;"
        + "&lt;body&gt;"
        + "&lt;table width='100%' cellpadding='0' cellspacing='0'&gt;"
        + "&lt;tr&gt;"
        + "&lt;td&gt;"
	    + generateHeader()
	    + "&lt;table width='100%' cellpadding='10' cellspacing='0'&gt;"
        + "&lt;tr&gt;"
        + "&lt;td&gt;"
	    + "&lt;table align='center' width='95%' cellpadding='0' cellspacing='0' class='singleborder_blue' bgcolor='#FFFFFF' &gt;"
	    + "&lt;tr&gt;"
        + "&lt;td align='center'&gt;"
        + "&lt;img align='center' class='screenshot' src='"+imageSrc+"'/&gt;"
        + "&lt;br/&gt;"
        + "&lt;/td&gt;"
        + "&lt;/tr&gt;"
        + "&lt;/table&gt;"
        + "&lt;/td&gt;"
        + "&lt;/tr&gt;"
        + "&lt;/table&gt;"
        + "&lt;table width='100%' bgcolor='#1D488D' cellpadding='10' cellspacing='0'&gt;" 
        + "&lt;tr&gt;"
        + "&lt;td align='center'&gt;&lt;font class='white'&gt;&amp;#xA9;<xsl:value-of select='$RES_PARAMETER_PARASOFT'/>&amp;#xA0;<xsl:value-of select='($toolName)'/>&amp;#xA0;<xsl:value-of select='($toolVer)'/>&amp;#xA0;<xsl:value-of select='$RES_PARAMETER_REPORTIMNG_SYSTEM'/>&amp;#xA0;&lt;/font&gt;&lt;/td&gt;"
        + "&lt;/tr&gt;"
        + "&lt;/table&gt;"
        + "&lt;/td&gt;"
        + "&lt;/tr&gt;"
        + "&lt;/table&gt;"
        + "&lt;/body&gt;"
        + "&lt;/html&gt;");
        win.document.close();
    }
    
    function popupScreenshots(id) {
        var screenshotData;
        if (document.getElementById) {
            var element = document.getElementById(id);
            if (element) {
                screenshotData = element.screenshotData;
            }
        }
        
        var win = window.open("", "_blank", "");
        win.document.write("&lt;html&gt;&lt;head&gt;&lt;title&gt;<xsl:value-of select='$RES_PARAMETER_SCREENSHOT_VIEWER'/>&lt;/title&gt;"
                + "&lt;style&gt;"
				+ "body {background-color: #E7F0F5;}"
                + "body, p, ol, td, pre { color: black; font-family: <xsl:value-of select="$base_font"/>,Helvetica,sans-serif; font-size: <xsl:value-of select="$base_font_size"/>; font-style: normal;}"
                + "FONT.white {font-size: <xsl:value-of select="$base_font_size"/>;font-family: <xsl:value-of select="$base_font"/>, Helvetica, sans-serif;color: #FFFFFF;}"
                + "IMG.screenshot {border:1px solid black;}"
                + "TABLE.parent {table-layout: fixed; word-wrap: break-word;}"
                + "TABLE.screenshot_container {border: 2px solid #CBCBCB; padding: 10px; margin: 10px; display:inline-block; zoom:1; *display:inline;} /* ie hack */"
				+ "TABLE.singleborder_blue{ border:2px solid #427fb6; height: 500px; padding-left:25px; padding-right:25px; padding-bottom:25px; padding-top:5px;}"
                + "TD.header {font-size: 18px; text-align: center; width: 100%; COLOR: #427fb6;}"
        		+ "DIV.header{font-size: 32px; FONT-FAMILY: Arial, Helvetica, sans-serif; COLOR: #427fb6 }"
                + "TD.screenshot_collection {padding: 10px; text-align: center; word-wrap: break-word;}"
                + "TD.screenshot_label {padding: 0px; text-align: center; margin-left:auto; margin-right:auto;}"
                + "&lt;/style&gt;"
                + "&lt;script language=\x22JavaScript\x22&gt;"
                + "function popupScreenshot(imageSrc) {"
                			
		+ "var win = window.open(\x22\x22,\x22_blank\x22,\x22\x22);"
        + "win.document.write(\x22&lt;html&gt;&lt;head&gt;&lt;title&gt;<xsl:value-of select='$RES_PARAMETER_SCREENSHOT_VIEWER'/>&lt;/title&gt;\x22"
        + "+ \x22&lt;style&gt;\x22"
        + "+ \x22body {background-color: #E7F0F5;}\x22"
        + "+ \x22body, p, ol, td, pre { color: black; font-family: <xsl:value-of select="$base_font"/>,Helvetica,sans-serif; font-size: <xsl:value-of select="$base_font_size"/>; font-style: normal;}\x22"
        + "+ \x22FONT.white {font-size: <xsl:value-of select="$base_font_size"/>;font-family: <xsl:value-of select="$base_font"/>, Helvetica, sans-serif;color: #FFFFFF;}\x22"
        + "+ \x22TABLE.singleborder_blue{ border:2px solid #427fb6; height: 500px; padding-left:25px; padding-right:25px; padding-bottom:25px; padding-top:5px;}\x22"
        + "+ \x22IMG.screenshot {border:1px solid black;}\x22"
        + "+ \x22TD.header {font-weight:bold; border: 1px solid #99aaaa; text-align: center; width: 100%; background-color: #ccdddd;}\x22"
        + "+ \x22&lt;/style&gt;\x22"
        + "+ \x22&lt;/head&gt;\x22"
        + "+ \x22&lt;body&gt;\x22"
        + "+ \x22&lt;table width='100%' cellpadding='0' cellspacing='0'&gt;\x22"
        + "+ \x22&lt;tr&gt;\x22"
        + "+ \x22&lt;td&gt;\x22"
	    + "+ \x22&lt;table xmlns:textutil=&#39;textutil&#39; xmlns:authors=&#39;authors&#39; width=&#39;100%&#39; cellpadding=&#39;0&#39; cellspacing=&#39;0&#39;>&lt;tr>&lt;td bgcolor=&#39;#3965A6&#39;  &#34;+<xsl:value-of select='($encoded_header_exp_background)'/>+&#34;  height=&#39;80px&#39; width=&#39;30%&#39; align=&#39;left&#39;>&#34;+<xsl:value-of select='($encoded_header_logo_img)'/>+&#34;&lt;/td>&lt;td bgcolor=&#39;#3965A6&#39;  &#34;+<xsl:value-of select='($encoded_header_exp_background)'/>+&#34;  height=&#39;80px&#39; width=&#39;40%&#39; align=&#39;center&#39;>&#34;+<xsl:value-of select='($encoded_header_img)'/>+&#34;&lt;/td>&lt;td bgcolor=&#39;#3965A6&#39;  &#34;+<xsl:value-of select='($encoded_header_exp_background)'/>+&#34;  height=&#39;80px&#39; width=&#39;30%&#39; align=&#39;center&#39;>&lt;/td>&lt;/tr>&lt;/table>\x22"
	    + "+ \x22&lt;table width='100%' cellpadding='10' cellspacing='0'&gt;\x22"
        + "+ \x22&lt;tr&gt;\x22"
        + "+ \x22&lt;td&gt;\x22"
	    + "+ \x22&lt;table align='center' width='95%' cellpadding='0' cellspacing='0' class='singleborder_blue' bgcolor='#FFFFFF' &gt;\x22"
	    + "+ \x22&lt;tr&gt;\x22"
        + "+ \x22&lt;td align='center'&gt;\x22"
        + "+ \x22&lt;img align='center' class='screenshot' src='\x22+imageSrc+\x22'/&gt;\x22"
        + "+ \x22&lt;br/&gt;\x22"
        + "+ \x22&lt;/td&gt;\x22"
        + "+ \x22&lt;/tr&gt;\x22"
        + "+ \x22&lt;/table&gt;\x22"
        + "+ \x22&lt;/td&gt;\x22"
        + "+ \x22&lt;/tr&gt;\x22"
        + "+ \x22&lt;/table&gt;\x22"
        + "+ \x22&lt;table width='100%' bgcolor='#1D488D' cellpadding='10' cellspacing='0'&gt;\x22" 
        + "+ \x22&lt;tr&gt;\x22"
        + "+ \x22&lt;td align='center'&gt;&lt;font class='white'&gt;&amp;#xA9;<xsl:value-of select='$RES_PARAMETER_PARASOFT'/>&amp;#xA0;<xsl:value-of select='($toolName)'/>&amp;#xA0;<xsl:value-of select='($toolVer)'/>&amp;#xA0;<xsl:value-of select='$RES_PARAMETER_REPORTIMNG_SYSTEM'/>&amp;#xA0;&lt;/font&gt;&lt;/td&gt;\x22"
        + "+ \x22&lt;/tr&gt;\x22"
        + "+ \x22&lt;/table&gt;\x22"
        + "+ \x22&lt;/td&gt;\x22"
        + "+ \x22&lt;/tr&gt;\x22"
        + "+ \x22&lt;/table&gt;\x22"
        + "+ \x22&lt;/body&gt;\x22"
        + "+ \x22&lt;/html&gt;\x22);"
                                               
                + "win.document.close();"
                + "}"
                + "&lt;"+"/script&gt;"
                + "&lt;/head&gt;"
                
                
        + "&lt;body&gt;"
        + "&lt;table width='100%' cellpadding='0' cellspacing='0'&gt;"
        + "&lt;tr&gt;"
        + "&lt;td&gt;"
	    + generateHeader()
	    + "&lt;table width='100%' cellpadding='10' cellspacing='0'&gt;"
        + "&lt;tr&gt;"
        + "&lt;td&gt;"
	    + "&lt;table align='center' width='95%' cellpadding='0' cellspacing='0' class='singleborder_blue' bgcolor='#FFFFFF' &gt;"
	    + "&lt;tr&gt;"
        + "&lt;td align='center'&gt;"
        
        
                + "&lt;table width='95%' cellspacing='0' cellpadding='0'&gt;"
                + "&lt;tr&gt;&lt;td&gt;&lt;div align='center' valign='top' class='header'&gt;<xsl:value-of select='$RES_PARAMETER_SCREENSHOTS'/>&lt;/div&gt;&lt;/td&gt;&lt;/tr&gt;"
                + "&lt;/table&gt;"
                + "&lt;br/&gt;"
                + "&lt;table width='95%' cellspacing='0' cellpadding='0' bordercolor='#99aaaa' border='0' class='parent'&gt;"
                + "&lt;tr&gt;"
                + "&lt;td class='screenshot_collection' align='center'&gt;");
                

        
        for (var i = 0; i &lt; screenshotData.length; ++i) {
            var data = screenshotData[i];
            win.document.write("&lt;table cellspacing='0' cellpadding='0' border='0' class='screenshot_container'&gt;"
                + "&lt;tr&gt;&lt;td&gt;"
                + "&lt;div onmouseover=\x22this.style.cursor='pointer';\x22 onclick=\x22popupScreenshot('"+data.src+"')\x22&gt;"
                + "&lt;img class='screenshot' width='"+data.width+"' height='"+data.height+"' src='"+data.src+"'&gt;"
                + "&lt;/div&gt;"
                + "&lt;/td&gt;&lt;/tr&gt;"
                + "&lt;tr&gt;&lt;td class='screenshot_label'&gt;"+data.label+"&lt;/td&gt;&lt;/tr&gt;"
                + "&lt;/table&gt;");
        }
                
        win.document.write(
		"&lt;/td&gt;"
        + "&lt;/tr&gt;"
        + "&lt;/table&gt;"
        + "&lt;/td&gt;"
        + "&lt;/tr&gt;"
        + "&lt;/table&gt;"
        + "&lt;/br&gt;"
        + "&lt;table width='100%' bgcolor='#1D488D' cellpadding='10' cellspacing='0'&gt;" 
        + "&lt;tr&gt;"
        + "&lt;td align='center'&gt;&lt;font class='white'&gt;&amp;#xA9;<xsl:value-of select='$RES_PARAMETER_PARASOFT'/>&amp;#xA0;<xsl:value-of select='($toolName)'/>&amp;#xA0;<xsl:value-of select='($toolVer)'/>&amp;#xA0;<xsl:value-of select='$RES_PARAMETER_REPORTIMNG_SYSTEM'/>&amp;#xA0;&lt;/font&gt;&lt;/td&gt;"
        + "&lt;/tr&gt;"
        + "&lt;/table&gt;"
        + "&lt;/td&gt;"
        + "&lt;/tr&gt;"
        + "&lt;/table&gt;"
        + "&lt;/body&gt;"
        + "&lt;/html&gt;");
        
        win.document.close();
    }
    
    function storeScreenshotData(id, src, label, width, height) {
        if (document.getElementById) {
            var element = document.getElementById(id);
            if (!element.screenshotData) {
                element.screenshotData = new Array();
            }
            var data = new Object();
            data.id = id;
            data.src = src;
            data.label = label;
            data.width = width;
            data.height = height;
            element.screenshotData.push(data);
        }
    }
    </xsl:variable>
    
    <xsl:variable name="showDetailedMessage">
    function showDetails(time, id) {
        var doc = window.open(&#34;&#34;,&#34;_blank&#34;,&#34;&#34;);
        var details = document.getElementById(id).value;
        doc.document.write(
            &#34;&lt;!DOCTYPE html PUBLIC &#39;-//W3C//DTD XHTML 1.0 Transitional//EN&#39; &#39;http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd&#39;&gt;&#34;+
            &#34;&lt;html xmlns=&#39;http://www.w3.org/1999/xhtml&#39;&gt;&#34;+
            &#34;&lt;head&gt;&#34;+            
            &#34;&lt;title&gt;<xsl:value-of select='$RES_PARAMETER_DETAILED_ERROR_MESSAGE_LOWERCASE'/>&lt;/title&gt;&#34;+
            &#34;&lt;style type=&#39;text/css&#39;&gt;&#34;+
	    &#34;&lt;!--&#34;+
	    &#34;BODY,P,OL,TD,pre{font-family: <xsl:value-of select="$base_font"/>, Helvetica, sans-serif;font-size: <xsl:value-of select="$base_font_size"/>;font-style: normal;color: #000000;}&#34;+
	    &#34;DIV.header{font-size: 32px; FONT-FAMILY: Arial, Helvetica, sans-serif; COLOR: #427fb6 }&#34;+
	    &#34;DIV.small_header{font-size: <xsl:value-of select="$small_header_font_size"/>; FONT-FAMILY: <xsl:value-of select="$base_font"/>, Helvetica, sans-serif; COLOR: #427fb6 }&#34;+
	    &#34;FONT.time {font-size: <xsl:value-of select="$time_font_size"/>;font-family: <xsl:value-of select="$base_font"/>, Helvetica, sans-serif;color: #000000; padding-left:10px;}&#34;+
	    &#34;FONT.white {font-size: <xsl:value-of select="$base_font_size"/>;font-family: <xsl:value-of select="$base_font"/>, Helvetica, sans-serif;color: #FFFFFF;}&#34;+
	    &#34;TD.singleborder{ border:1px solid #CBCBCB}&#34;+
	    &#34;TABLE.header{background-color:#FFFFFF}&#34;+
	    &#34;TABLE.singleborder_blue{ border:2px solid #427fb6; height: 500px; padding-left:25px; padding-right:25px; padding-bottom:25px; padding-top:5px;}&#34;+
	    &#34;TABLE.singleborder{ border:1px solid #CBCBCB}&#34;+
	    &#34;TABLE.doubleborder{ border:2px solid #CBCBCB}&#34;+
            &#34;body {background-color: #E7F0F5;}&#34;+
            &#34;#detailedMessage {width:100%; height: 500px; resize: none; border-style: none; border-color: Transparent; outline: none; padding:0px; overflow:auto;}&#34;+
            &#34;.messageHeader {width:100%; background-color:#ccdddd; border: solid 1px #99aaaa; text-align:center;}&#34;+
            &#34;--&gt;&#34;+
            &#34;&lt;/style&gt;&lt;/head&gt;&#34;+
	    &#34;&lt;body&gt;&#34;+
			generateHeader() +
            &#34;&lt;table width=&#39;100%&#39; cellspacing=&#39;0&#39;&gt;&#34;+
            &#34;&lt;tr&gt;&#34;+
            &#34;&lt;td style=&#39;padding:5px&#39; align=&#39;center&#39;&gt;&#34;+
            &#34;&lt;font class=&#39;time&#39;&gt;&#34;+time+&#34;&lt;/font&gt;&#34;+
            &#34;&lt;/td&gt;&#34;+
            &#34;&lt;/tr&gt;&#34;+
            &#34;&lt;tr&gt;&#34;+
            &#34;&lt;td align=&#39;center&#39;&gt;&#34;+
            &#34;&lt;table align=&#39;center&#39; width=&#39;95%&#39; class=&#39;singleborder_blue&#39; cellpadding=&#39;0&#39; cellspacing=&#39;0&#39; bgcolor=&#39;#FFFFFF&#39;&gt;&#34;+
            &#34;&lt;tr&gt;&lt;td align=&#39;center&#39; valign=&#39;top&#39;&gt;&#34;+
            &#34;&lt;table border=&#39;0&#39; cellpadding=&#39;0&#39; cellspacing=&#39;0&#39; bordercolor=&#39;#99aaaa&#39;&gt;&#34;+

	    &#34;&lt;tr&gt;&#34;+
	    &#34;&lt;td&gt;&lt;div class=&#39;header&#39; align=&#39;center&#39;&gt;<xsl:value-of select='$RES_PARAMETER_DETAILED_ERROR_MESSAGE'/>&lt;/div&gt;&lt;/td&gt;&#34;+
            &#34;&lt;/tr&gt;&#34;+
            &#34;&lt;/table&gt;&#34;+
	    &#34;&lt;br /&gt;&#34;+
	    &#34;&lt;table class=&#39;doubleborder&#39; width=&#39;100%&#39; cellspacing=&#39;0&#39; cellpadding=&#39;0&#39;&gt;&#34;+
            &#34;&lt;tr&gt;&#34;+            
			&#34;&lt;td align=&#39;left&#39;&gt;&lt;textarea name=&#39;detailedMessage&#39; id=&#39;detailedMessage&#39;&gt;&#34;+details+&#34;&lt;/textarea&gt;&lt;/td&gt;&#34;+
            &#34;&lt;/tr&gt;&#34;+
	    &#34;&lt;/table&gt;&#34;+
            &#34;&lt;/td&gt;&#34;+
	    &#34;&lt;/tr&gt;&#34;+
	    &#34;&lt;/table&gt;&#34;+
            &#34;&lt;/td&gt;&#34;+
	    &#34;&lt;/tr&gt;&#34;+
	    &#34;&lt;/table&gt;&#34;+
	    &#34;&lt;br /&gt;&#34;+
            &#34;&lt;table align=&#39;center&#39; width=&#39;100%&#39; bgcolor=&#39;#1D488D&#39; cellpadding=&#39;10&#39; cellspacing=&#39;0&#39;&gt;&#34;+
	    &#34;&lt;tr&gt;&#34;+
            &#34;&lt;td align=&#39;center&#39;&gt;&lt;font class=&#39;white&#39;&gt;&amp;#xA9;<xsl:value-of select='$RES_PARAMETER_PARASOFT'/>&amp;#xA0;<xsl:value-of select='($toolName)'/>&amp;#xA0;<xsl:value-of select='($toolVer)'/>&amp;#xA0;<xsl:value-of select='$RES_PARAMETER_REPORTIMNG_SYSTEM'/>&amp;#xA0;&lt;/font&gt;&lt;/td&gt;&#34;+
            &#34;&lt;/tr&gt;&#34;+
            &#34;&lt;/table&gt;&#34;+
            &#34;&lt;/body&gt;&#34;+
            &#34;&lt;/html&gt;&#34;);
            doc.document.close();
    }
    </xsl:variable>

    <xsl:variable name="time" select="/ResultsSession/@time"/>
    <xsl:variable name="toolName" select="/ResultsSession/@toolName"/>
    <xsl:variable name="toolVer" select="/ResultsSession/@toolVer"/>
    <xsl:variable name="os_name" select="/ResultsSession/@os_name"/>    
    <xsl:variable name="org_time" select="/ResultsSession/@date" saxon:assignable="yes"/>
    <xsl:variable name="testing_process_problems" select="count(/ResultsSession/*/TestingProcessProblems)"/>
    <xsl:variable name="codereview" select="count(/ResultsSession/CodeReview)"/>

    <xsl:variable name="goals" select="count(/ResultsSession/Goals/Goal[@active = 'true'])"/>
    
    <xsl:variable name="statistics" select="count(/ResultsSession/Statistics/History/Graph)"/>
    
    <xsl:variable name="cr_graph_id">cr</xsl:variable>
    <xsl:variable name="cr_history" select="count(/ResultsSession/CodeReview/History/Graph[@id=$cr_graph_id])"/>
    
    <xsl:variable name="metrics" select="count(/ResultsSession/Metrics)"/>
    <xsl:variable name="metrics_nmb" select="count(/ResultsSession/Metrics/Metric)"/>
    <xsl:variable name="metrics_inv_symbols" select="/ResultsSession/Metrics/@invSymbols"/>
    
    <xsl:variable name="coding_standards" select="count(/ResultsSession/CodingStandards)"/>
    <xsl:variable name="cs_projects_nmb" select="count(/ResultsSession/CodingStandards/Projects/Project)"/>
    <xsl:variable name="cs_errors_nmb" select="count(/ResultsSession/CodingStandards/StdViols/*[not(@supp='true')])"/>
    <xsl:variable name="cs_supp_errors_nmb" select="count(/ResultsSession/CodingStandards/StdViols/*[@supp='true'])"/>
    <xsl:variable name="cs_rules" select="count(/ResultsSession/CodingStandards/Rules)"/>

    <xsl:variable name="checkedlines_graph_id">lns</xsl:variable>
    <xsl:variable name="cs_history" select="count(/ResultsSession/CodingStandards/History/Graph[@id=$checkedlines_graph_id])"/>
    
    <xsl:variable name="functional" select="count(/ResultsSession/FunctionalTests)"/>
    <xsl:variable name="func_errors_nmb" select="count(/ResultsSession/FunctionalTests/FuncViols/*[not(@supp='true')])"/>
    
    <xsl:variable name="apicoverage" select="count(/ResultsSession/APICoverage/service)"/>

    <xsl:variable name="change_advisor" select="count(/ResultsSession/ChangeAdvisor)"/>
    <xsl:variable name="change_impacts_nmb" select="count(/ResultsSession/ChangeAdvisor/ChangeImpacts/*[not(@supp='true')])"/>

    <xsl:variable name="func_tasks_graph_id">tsks</xsl:variable> 
    <xsl:variable name="func_testcases_graph_id">tc</xsl:variable>
     
    <xsl:variable name="func_tc_history" select="count(/ResultsSession/FunctionalTests/History/Graph[@id=$func_testcases_graph_id])"/>
    <xsl:variable name="func_history" select="count(/ResultsSession/FunctionalTests/History/Graph[@id=$func_tasks_graph_id])"/>

    <xsl:variable name="generation" select="count(/ResultsSession/Generation)"/>
    <xsl:variable name="tg_projects_info_nmb" select="count(/ResultsSession/Generation/Projects/GenerationProjectInfo)"/>
    <xsl:variable name="tg_info_nmb" select="count(/ResultsSession/Generation/GenerationInformations/GenerationInfo)"/>
    
    <xsl:variable name="execution" select="count(/ResultsSession/Exec)"/>
    <xsl:variable name="exec_errors_nmb" select="count(/ResultsSession/Exec/ExecViols/*[not(@supp='true')])"/>
    <xsl:variable name="exec_supp_errors_nmb" select="count(/ResultsSession/Exec/ExecViols/*[@supp='true'])"/>

    <xsl:variable name="subCategoryId_LeakSummary">13</xsl:variable> 
    
    <xsl:variable name="exec_tasks_graph_id">tsks</xsl:variable> 
    <xsl:variable name="exec_testcases_graph_id">tc</xsl:variable>
     
    <xsl:variable name="exec_tc_history" select="count(/ResultsSession/Exec/History/Graph[@id=$exec_testcases_graph_id])"/>
    <xsl:variable name="exec_history" select="count(/ResultsSession/Exec/History/Graph[@id=$exec_tasks_graph_id])"/>
    
    <xsl:variable name="exec_proj" select="count(/ResultsSession/Exec/Projects/*)"/>
    
    <xsl:variable name="exec_cvg" select="count(/ResultsSession/Exec/Coverage)"/>    
    <xsl:variable name="exec_cvg_types" select="count(/ResultsSession/Exec/Coverage/Types/CvgType)"/>

    <xsl:variable name="exec_cvg_graph_id">cvg</xsl:variable>
    <xsl:variable name="exec_cvg_history" select="count(/ResultsSession/Exec/Coverage/History/Graph[@id=$exec_cvg_graph_id])"/>
    
    <xsl:variable name="cs_goal_mode" select="/ResultsSession/CodingStandards/Goal/@mode"/>
    <xsl:variable name="cs_goal_date" select="/ResultsSession/CodingStandards/Goal/@date"/>
    <xsl:variable name="cs_goal_happy" select="/ResultsSession/CodingStandards/Goal/@happy"/>
    <xsl:variable name="cs_goal_happy_only" select="/ResultsSession/CodingStandards/Goal/@onlyHappy"/>

    <xsl:variable name="goals_graph_id">gls</xsl:variable> 
    <xsl:variable name="goals_history" select="count(/ResultsSession/Goals/History/Graph[@id=$goals_graph_id])"/>

    <xsl:variable name="memory_session_statistics">memory_session_statistics</xsl:variable> 
    <xsl:variable name="time_session_statistics">time_session_statistics</xsl:variable>
    <xsl:variable name="memory_stats_history" select="count(/ResultsSession/Statistics/History/Graph[@id=$memory_session_statistics])"/>
    <xsl:variable name="time_stats_history" select="count(/ResultsSession/Statistics/History/Graph[@id=$time_session_statistics])"/>

    <xsl:variable name="static_details" select="count(/ResultsSession/CodingStandards/TestedFilesDetails/*)"/>    
    <xsl:variable name="cr_details" select="count(/ResultsSession/CodeReview/CodeReviewDetails/*)"/>
    <xsl:variable name="exec_details" select="count(/ResultsSession/ExecutedTestsDetails/*)"/>    

    <xsl:variable name="first_back_to_top" saxon:assignable="yes">true</xsl:variable>

   <!-- =========== extracts total value for author from list of authors values =================== -->
   
    <saxon:function name="results:getTotalValue">
       <xsl:param name="values"/>
       <xsl:param name="authidx"/>   
    
       <xsl:variable name="currauthidx" saxon:assignable="yes">1</xsl:variable>
       <xsl:variable name="value" saxon:assignable="yes" select="$values"/>
       <saxon:while test="$currauthidx &lt; $authidx">
          <saxon:assign name="currauthidx" select="$currauthidx+1"/>
          <saxon:assign name="value" select="substring-after($value,';')"/>                           
       </saxon:while>
       <saxon:return select="substring-before($value,';')"/>    
                    
    </saxon:function>

    <!-- =========== calculates sum for items on the same positions from given lists e.g. for '0,0,2' and '2,3,3' the result is '2,3,5' ============ -->

    <saxon:function name="results:makeSUM">
    
        <xsl:param name="input1"/>
        <xsl:param name="input2"/>
        <xsl:param name="separator"/>

        <xsl:variable name="returnValue" saxon:assignable="yes"></xsl:variable>

        <xsl:if test="string-length($input1) = 0">
            <saxon:assign name="returnValue" select="$input2"/> 
        </xsl:if>
        <xsl:if test="string-length($input2) = 0">
            <saxon:assign name="returnValue" select="$input1"/> 
        </xsl:if>       

        <xsl:if test="string-length($returnValue) = 0">

            <xsl:variable name="valueItr1" saxon:assignable="yes" select="$input1"/>
            <xsl:variable name="valueItr2" saxon:assignable="yes" select="$input2"/>

            <xsl:variable name="value1" saxon:assignable="yes"/>
            <xsl:variable name="value2" saxon:assignable="yes"/>
       
            <saxon:while test="string-length($valueItr1) > 0 and string-length($valueItr2) > 0">
       
                <saxon:assign name="value1" select="substring-before($valueItr1,$separator)"/>                           
                <saxon:assign name="value2" select="substring-before($valueItr2,$separator)"/>
                                     
                <saxon:assign name="valueItr1" select="substring-after($valueItr1,$separator)"/>                           
                <saxon:assign name="valueItr2" select="substring-after($valueItr2,$separator)"/>
                                     
                <saxon:assign name="returnValue" select="concat($returnValue,$value1 + $value2,$separator)"/>                           
            </saxon:while>
        </xsl:if>       
       
        <saxon:return select="$returnValue"/>    
                    
    </saxon:function>

   
    <!-- =========== compares authors according to ignore case settings  ============ -->
    
    <saxon:function name="authors:compare">
        <xsl:param name="author1"/>
        <xsl:param name="author2"/>   
        
        <xsl:if test="$authors_ignorecase = 'true'">             
            <saxon:return select="textutil:uppercase($author1)= textutil:uppercase($author2)"/>
        </xsl:if>
        <xsl:if test="$authors_ignorecase != 'true'">                                  
            <saxon:return select="$author1 = $author2"/>            
        </xsl:if>                        
    </saxon:function>

    <!-- ========  Split string with newlines if too long ========== -->
    <!-- Note: Use for PDF spacing only - otherwise, use css padding, word-wrap: break-word, and max-width instead. -->
    <xsl:template name="split_if_needed">
        <xsl:param name="value"/>
        <xsl:param name="length" select="75"/>
        <xsl:param name="indent" select="0"/>
        <xsl:variable name="line" select="substring($value, 1, $length - $indent*4)"/>
        <xsl:variable name="remainder" select="substring($value, $length - $indent*4 + 1)"/>
        <xsl:if test="$line">
            <xsl:value-of select="$line"/>
        </xsl:if>
        <xsl:if test="$remainder"><br/>
            <xsl:if test="($report_format_mode='pdf' or $report_type = $email_report) and $indent > 0">
                <xsl:call-template name="repeat_n">
                    <xsl:with-param name="str" select="'&#160;'"/>
                    <xsl:with-param name="n" select="$indent * 4"/>
                </xsl:call-template>
            </xsl:if>
            <xsl:call-template name="split_if_needed">
                <xsl:with-param name="value" select="$remainder"/>
                <xsl:with-param name="length" select="$length"/>
                <xsl:with-param name="indent" select="$indent"/>
            </xsl:call-template>
        </xsl:if>
    </xsl:template>

    <!-- =================  Repeats 'str' n times ==================== -->
    <xsl:template name="repeat_n">
        <xsl:param name="str"/>
        <xsl:param name="n" select="0"/>
        <xsl:if test="$n &gt; 0">
            <xsl:value-of select="$str"/>
            <xsl:call-template name="repeat_n">
                <xsl:with-param name="str" select="$str"/>
                <xsl:with-param name="n" select="$n - 1"/>
            </xsl:call-template>
        </xsl:if>
    </xsl:template>

    <!-- =================  print goals ============================ -->

    <xsl:template name="print_goals">
       <xsl:param name="violationsList"/>

       <xsl:variable name="prevGoals" saxon:assignable="yes"></xsl:variable>
       <xsl:variable name="goalsResult" saxon:assignable="yes"></xsl:variable>
       <xsl:variable name="separator">,</xsl:variable>
    
       <xsl:for-each select="$violationsList">
           <xsl:sort select="@goals"/>
           
           <xsl:variable name="currGoals" select="@goals"/>
           <xsl:if test="$currGoals != $prevGoals">             
              <saxon:assign name="prevGoals" select="$currGoals"/>
              <saxon:assign name="goalsResult" select="results:makeSUM($goalsResult,$currGoals,$separator)"/>
          </xsl:if>           
       </xsl:for-each> 
     
       <xsl:call-template name="print_active_goals">
          <xsl:with-param name="activeGoals" select="$goalsResult"/>
          <xsl:with-param name="separator" select="$separator"/>
       </xsl:call-template>
    
    </xsl:template>
    
    <!-- =================  print active goals ============================ -->
    
    <xsl:template name="print_active_goals">    
       <xsl:param name="activeGoals"/>
       <xsl:param name="separator"/>
    
       <xsl:variable name="idx" saxon:assignable="yes">1</xsl:variable>
       <xsl:variable name="dispIdx" saxon:assignable="yes">1</xsl:variable>

       <xsl:variable name="activeGoalsItr" saxon:assignable="yes" select="$activeGoals"/>
       <xsl:variable name="value" saxon:assignable="yes"/>

       <saxon:while test="string-length($activeGoalsItr) > 0">
       
          <saxon:assign name="value" select="substring-before($activeGoalsItr,$separator)"/>
          <saxon:assign name="activeGoalsItr" select="substring-after($activeGoalsItr,$separator)"/>
          
          <xsl:if test="$value > 0 and /ResultsSession/Goals/Goal[$idx]/@active = 'true'">
            <xsl:if test="$dispIdx > 1">
               ,<xsl:value-of select="($nbsp)" disable-output-escaping="yes"/>
            </xsl:if>
            <xsl:value-of select="/ResultsSession/Goals/Goal[$idx]/@name"/>                        
            <saxon:assign name="dispIdx" select="$dispIdx + 1"/>
          </xsl:if>
          <saxon:assign name="idx" select="$idx + 1"/>
                                     
       </saxon:while>
           
    </xsl:template>

    <!-- =================  make indentation using spaces ============================ -->
    
    <xsl:template name="make_indentation">    
       <xsl:param name="indentation"/>
    
       <xsl:variable name="idx" saxon:assignable="yes">0</xsl:variable>
       
       <saxon:while test="$indentation > $idx">
          <saxon:assign name="idx" select="$idx+1"/>
          <xsl:value-of select="($nbsp)" disable-output-escaping="yes"/>                        
       </saxon:while>
           
   	</xsl:template>

    <!-- =================  format time ============================ -->

    <xsl:template name="format_time">
       <saxon:assign name="org_time" select="translate($org_time,' ','_')"/>
       <saxon:assign name="org_time" select="translate($org_time,'/','-')"/>
       <saxon:assign name="org_time" select="translate($org_time,':','-')"/>
    </xsl:template>

    <!-- =============== img_ref ============== -->

    <xsl:template name="img_ref">
    <xsl:param name="src"/>
    <xsl:param name="alt"/>

    <xsl:call-template name="image_ref">
    <xsl:with-param name="src" select="($src)"/>
    <xsl:with-param name="alt" select="($alt)"/>
    <xsl:with-param name="ext" select="'.jpeg'"/>
    </xsl:call-template>

    </xsl:template>

    <!-- =============== image_ref ============== -->
    
    <xsl:template name="image_ref">
    <xsl:param name="src"/>
    <xsl:param name="alt"/>
    <xsl:param name="ext"/>
    <xsl:param name="height"/>
    
    <xsl:if test="(($report_type) = ($disk_report)) or ($report_format_mode='pdf')">
	    <img src="{$src}" alt="{$alt}">    
		   	<xsl:if test="$height">
		   		<xsl:attribute name="height"><xsl:value-of select="$height"/></xsl:attribute>
		   	</xsl:if>
	   	</img>
    </xsl:if>    
    <xsl:if test="(($report_type) = ($email_report)) and not($report_format_mode='pdf')">
       <xsl:if test="not($attachments = 'true')">
       <xsl:variable name="src_name" select="substring-before($src,'.')"/>
       <img src="cid:{$src_name}" alt="{$src_name}"></img>
       </xsl:if>
       <xsl:if test="$attachments = 'true'">
       <img src="{$src}" alt="{$alt}"/>    
       </xsl:if>
    </xsl:if>    
    <xsl:if test="($report_type) = ($tcm_report)">
    <xsl:variable name="jsp_src" select="concat('/results/img_ref.jsp?id=',$src)"/>
    <img src="{$jsp_src}" alt="{$alt}"></img>
    </xsl:if>
    </xsl:template>

    <!-- =============== encoded_image_ref ============== -->
    
    <xsl:template name="encoded_image_ref">
       <xsl:param name="src"/>
       <xsl:param name="alt"/>
    
       <xsl:if test="(($report_type) = ($disk_report)) or ($report_format_mode='pdf')">
       &#34;&lt;img src=&#39;<xsl:value-of select="($src)"/>&#39; alt=&#39;<xsl:value-of select="($alt)"/>&#39;/>&#34;    
       </xsl:if>    
       <xsl:if test="($report_type) = ($tcm_report)">
       <xsl:variable name="jsp_src" select="concat('/results/img_ref.jsp?id=',$src)"/>
        &#34;&lt;img src=&#39;<xsl:value-of select="($jsp_src)"/>&#39; alt=&#39;<xsl:value-of select="($alt)"/>&#39;/>&#34;
       </xsl:if>
    </xsl:template>
    
    <!-- =============== encoded_background ============== -->
    
    <xsl:template name="encoded_background">
       <xsl:param name="src"/>
    
       <xsl:if test="(($report_type) = ($disk_report)) or ($report_format_mode='pdf')">
       &#34;background=&#39;<xsl:value-of select="($src)"/>&#39;&#34;    
       </xsl:if>    
       <xsl:if test="($report_type) = ($tcm_report)">
       <xsl:variable name="jsp_src" select="concat('/results/img_ref.jsp?id=',$src)"/>
       &#34;background=&#39;<xsl:value-of select="($jsp_src)"/>&#39;&#34;    
       </xsl:if>
    </xsl:template>

    <!-- =============== img_background ============== -->
    
    <xsl:template name="img_background">
    <xsl:param name="bkg"/>
    <xsl:param name="src"/>
    <xsl:param name="alt"/>
    <xsl:param name="align"/>
    <xsl:param name="width"/>
    <xsl:param name="height"/>
    
    <xsl:if test="(($report_type) = ($disk_report)) or ($report_format_mode='pdf')">    
    <td bgcolor="{$headerblue_color}" background="{$bkg}" height="80px" width="{$width}" align="{$align}">
    <xsl:if test="$src">
	    <xsl:call-template name="image_ref">
	    <xsl:with-param name="src" select="($src)"/>   
	    <xsl:with-param name="alt" select="($alt)"/>
	    <xsl:with-param name="ext" select="'.jpg'"/>
	    <xsl:with-param name="height" select="$height"/>
	    </xsl:call-template>
 	</xsl:if>    
    </td>
    </xsl:if>    
    <xsl:if test="(($report_type) = ($email_report)) and not($report_format_mode='pdf')">
       <xsl:if test="not($attachments = 'true')">
   		<xsl:variable name="src_name" select="substring-before($bkg,'.jpg')"/>
     		<td bgcolor="{$headerblue_color}" background="cid:{$src_name}" width="{$width}" align="{$align}">
		<xsl:if test="$src">
	       <xsl:call-template name="image_ref">
	       <xsl:with-param name="src" select="($src)"/>   
	       <xsl:with-param name="alt" select="($alt)"/>
	       <xsl:with-param name="ext" select="'.jpg'"/>
	       </xsl:call-template>    
       </xsl:if>
       </td>
       </xsl:if>
       <xsl:if test="$attachments = 'true'">
       <td bgcolor="{$headerblue_color}" background="{$bkg}" width="{$width}" align="{$align}">
       <xsl:if test="$src">
	       <xsl:call-template name="image_ref">
	       <xsl:with-param name="src" select="($src)"/>   
	       <xsl:with-param name="alt" select="($alt)"/>
	       <xsl:with-param name="ext" select="'.jpg'"/>   
	       </xsl:call-template>
       </xsl:if>    
       </td>
       </xsl:if>
    </xsl:if>    
    <xsl:if test="(($report_type) = ($tcm_report)) and not($report_format_mode='pdf')">
    <xsl:variable name="jsp_src" select="concat('/results/img_ref.jsp?id=',$bkg)"/>
    <td bgcolor="{$headerblue_color}" background="{$jsp_src}" width="{$width}" align="{$align}">
    <xsl:if test="$src">
	    <xsl:call-template name="image_ref">
	    <xsl:with-param name="src" select="($src)"/>   
	    <xsl:with-param name="alt" select="($alt)"/>
	    <xsl:with-param name="ext" select="'.jpg'"/>
	    </xsl:call-template>
    </xsl:if>    
    </td>
    </xsl:if>
    </xsl:template>
    
    <!-- =============== standard_link_ref ============== -->
    
    <xsl:template name="standard_link_ref">
    <xsl:param name="href"/>
    <xsl:param name="label"/>
    <xsl:param name="class"/>
    <xsl:param name="id"/>
    <xsl:param name="email_class"/>
    <xsl:if test="(($report_type) = ($disk_report)) or (($report_type) = ($tcm_report)) or ($report_format_mode='pdf')">
    <xsl:if test="not(string-length($id) > 0)">
    <a  class="{$class}" href="{$href}">
    <xsl:value-of select="($label)"/>   
    </a>
    </xsl:if>
    <xsl:if test="(string-length($id) > 0)">
    <a id="{$id}" class="{$class}" href="{$href}">
    <xsl:value-of select="($label)"/>   
    </a>
    </xsl:if>
    </xsl:if>        
    <xsl:if test="(($report_type) = ($email_report)) and not($report_format_mode='pdf')">
    <xsl:if test="not(string-length($email_class) > 0)">
    <xsl:variable name="class_id" select="substring-before($class,'_link')"/>   
    <font class="{$class_id}">
    <xsl:value-of select="($label)"/>   
    </font> 
    </xsl:if>
    <xsl:if test="string-length($email_class) > 0">
    <font class="{$email_class}">
    <xsl:value-of select="($label)"/>   
    </font>
    </xsl:if>
    </xsl:if>
    </xsl:template>
    
    <!-- =================  format_author_total_delta ============================ -->
    
    <xsl:template name="format_author_total_delta">
       <xsl:param name="delta"/>
    
       <xsl:variable name="totalValue" saxon:assignable="yes">0</xsl:variable>
       <xsl:variable name="currValue" saxon:assignable="yes">0</xsl:variable>
       <xsl:variable name="restDeltas" saxon:assignable="yes" select="$delta"/>
       
       <saxon:while test="string-length($restDeltas) > 0">
          <saxon:assign name="currValue" select="substring-before($restDeltas,',')"/>                           
          <saxon:assign name="totalValue" select="$currValue + $totalValue"/>                           
          <saxon:assign name="restDeltas" select="substring-after($restDeltas,',')"/>                           
       </saxon:while>

       <xsl:call-template name="format_total_delta">
          <xsl:with-param name="delta" select="($totalValue)"/>
       </xsl:call-template>
    </xsl:template>         

    <xsl:template name="format_delta_position">
       <xsl:param name="delta"/>
       <xsl:param name="position"/>
    
       <xsl:variable name="idx" saxon:assignable="yes">0</xsl:variable>
       <xsl:variable name="restDeltas" saxon:assignable="yes" select="$delta"/>
       
       <saxon:while test="string-length($restDeltas) > 0 and $position > $idx">
          <saxon:assign name="idx" select="$idx + 1"/>                           
          <saxon:assign name="restDeltas" select="substring-after($restDeltas,',')"/>                           
       </saxon:while>

       <xsl:call-template name="format_total_delta">
          <xsl:with-param name="delta" select="substring-before($restDeltas,',')"/>
       </xsl:call-template>
    </xsl:template>         
    
    <xsl:template name="format_total_delta">
       <xsl:param name="delta"/>
        
       <xsl:variable name="fdelta" saxon:assignable="yes" select="($delta)"/>
       <xsl:if test="not($delta='0') and not(string-length(substring-after($delta,'-')) > 0)">
          <saxon:assign name="fdelta" select="concat('+',$fdelta)"/>
       </xsl:if>
       <xsl:value-of select="($fdelta)"/>  
    </xsl:template>

    <!-- =============== generate header ============== -->

    <xsl:template name="header_image">
    <xsl:variable name="img_uri1" select="concat(($output_dir),($header_exp_img))"/>
    <xsl:variable name="img_url1" select="translate($img_uri1, '\','/')"/>
    <xsl:variable name="img_uri2" select="concat(($output_dir),($header_img))"/>
    <xsl:variable name="img_url2" select="translate($img_uri2, '\','/')"/>
    <xsl:variable name="img_uri3" select="concat(($output_dir),($header_logo_img))"/>
    <xsl:variable name="img_url3" select="translate($img_uri3, '\','/')"/>
    <xsl:variable name="res_img" saxon:assignable="yes"></xsl:variable>
    <saxon:assign name="res_img" 
        select="graph:publish($img_url1,$header_exp_img)"/>
    <saxon:assign name="res_img" 
        select="graph:publish($img_url2,$header_img)"/>
    <saxon:assign name="res_img" 
        select="graph:publish($img_url3,$header_logo_img)"/>
        
    <table width="100%" cellpadding="0" cellspacing="0">
        <xsl:if test="($report_format_mode='pdf')">
            <xsl:attribute name="cols">30% 40% 30%</xsl:attribute>
        </xsl:if>
        <tr>
        
    <xsl:call-template name="img_background">
    <xsl:with-param name="bkg" select="($header_exp_img)"/>
    <xsl:with-param name="src" select="($header_logo_img)"/>   
    <xsl:with-param name="alt" select="($header_logo_img)"/>
    <xsl:with-param name="align">left</xsl:with-param>
    <xsl:with-param name="width">30%</xsl:with-param>
    <xsl:with-param name="height">54px</xsl:with-param>
    </xsl:call-template>
    
    <xsl:call-template name="img_background">
    <xsl:with-param name="bkg" select="($header_exp_img)"/>
    <xsl:with-param name="src" select="($header_img)"/>   
    <xsl:with-param name="alt" select="($header_img)"/>
    <xsl:with-param name="align">center</xsl:with-param>
    <xsl:with-param name="width">40%</xsl:with-param>
    <xsl:with-param name="height">54px</xsl:with-param>
    </xsl:call-template>
    
    <xsl:call-template name="img_background">
    <xsl:with-param name="bkg" select="($header_exp_img)"/>    
    <xsl:with-param name="align">center</xsl:with-param>
    <xsl:with-param name="width">30%</xsl:with-param>
    </xsl:call-template>
    </tr></table>
    </xsl:template>
    
    <!-- =================  authors_header ============================ -->
    <xsl:template name="authors_header">
    
    <table width='{$width}' border='0' cellpadding='0' cellspacing='0'>
    	<xsl:if test="($report_format_mode='pdf')">
            <xsl:attribute name="cols">20% 60% 20%</xsl:attribute>
        </xsl:if>
    <tr>
    <td width="20%"></td>
    <td width="60%" align="center"><div class="small_header"><xsl:value-of select="$RES_TASKS_BY_AUTHOR"/></div></td>
    <td width="20%" align="right">
       <xsl:if test="not($report_type = $email_report)">
         <xsl:call-template name="back_to_top"/>
       </xsl:if>
    </td>
    </tr>
    </table>    
        
    </xsl:template>
    
    <!-- =============== generate back to top  ============== -->
    
    <xsl:template name="back_to_top">
    	<xsl:if test="not($report_format_mode='pdf')">
    		<a class="blue_link" href="#top"><xsl:value-of select="$RES_BACK_TO_TOP"/></a>
    		<xsl:value-of select="($nbsp)" disable-output-escaping="yes" />
    		<xsl:value-of select="($nbsp)" disable-output-escaping="yes" />
    		<xsl:value-of select="($nbsp)" disable-output-escaping="yes" />
    	</xsl:if>
	</xsl:template>
	
	<!-- =============== generate analysis top link  ============== -->
	
	<xsl:template name="display_linked_menu_item">
	<xsl:param name="text" />
	<xsl:param name="link"/>
    <td align="left" nowrap="true">
        <a class="blue_link" href="{$link}"><b><xsl:value-of select="$text"/> &gt;</b></a> 
    </td>  
    </xsl:template>
	
	<!-- =================  pre-table header for author tables ============================ -->

	<xsl:template name="details_table_auth_header">
		<xsl:param name="auth" />
		<xsl:param name="number" />
		<xsl:param name="message" />
		<xsl:param name="colspan">2</xsl:param>
		<xsl:param name="anchor" />

		<td style="padding-left:20px;" colspan="{$colspan}" align="left" nowrap="nowrap">
			<xsl:if test="$anchor">
				<a name="{$anchor}"></a>
			</xsl:if>
			<b>
				<xsl:value-of select="($auth)" />
			</b>
			<xsl:value-of select="($nbsp)" disable-output-escaping="yes" />
			<xsl:value-of select="($nbsp)" disable-output-escaping="yes" />			
			<xsl:value-of select="$message" />			
			:
			<xsl:value-of select="($nbsp)" disable-output-escaping="yes" />
			<xsl:value-of select="($number)" />
		</td>
		<td align="right">
            <xsl:if test="not($report_type = $email_report) and ($number &gt; 0)">
                 <xsl:call-template name="back_to_top"/>
            </xsl:if>
		</td>

	</xsl:template>
	
    <!-- =============== generate footer ============== -->

    <xsl:template name="footer_image">
    <xsl:variable name="img_uri1" select="concat(($output_dir),($footer_exp_img))"/>
    <xsl:variable name="img_url1" select="translate($img_uri1, '\','/')"/>
    <xsl:variable name="img_uri2" select="concat(($output_dir),($footer_img))"/>
    <xsl:variable name="img_url2" select="translate($img_uri2, '\','/')"/>
    <xsl:variable name="res_img" saxon:assignable="yes"></xsl:variable>
    <saxon:assign name="res_img" 
        select="graph:publish($img_url1,$footer_exp_img)"/>
    <saxon:assign name="res_img" 
        select="graph:publish($img_url2,$footer_img)"/>
    <tr><td><br/><table width="{$width}" cellpadding="0" cellspacing="0">
        <xsl:if test="($report_format_mode='pdf')">
            <xsl:attribute name="cols">100%</xsl:attribute>
        </xsl:if>
        <tr>
    <xsl:call-template name="img_background">
    <xsl:with-param name="bkg" select="($footer_exp_img)"/>
    <xsl:with-param name="src" select="($footer_img)"/>   
    <xsl:with-param name="alt" select="($footer_img)"/>
    <xsl:with-param name="align">left</xsl:with-param>
    <xsl:with-param name="width">100%</xsl:with-param>
    </xsl:call-template>
    </tr></table></td></tr>
    </xsl:template>
    
    <!-- =============== generate graph ============== -->
        
    <xsl:template name="generate_graph">
        <xsl:param name="graph"/>
        <xsl:param name="img_name"/>
        <xsl:param name="auth"/>

        <xsl:variable name="x_data" saxon:assignable="yes"></xsl:variable>
        <xsl:variable name="y_data" saxon:assignable="yes"></xsl:variable>
        
        <xsl:variable name="title" saxon:assignable="yes"></xsl:variable>
        <xsl:variable name="x_title" saxon:assignable="yes"></xsl:variable>
        <xsl:variable name="y_title" saxon:assignable="yes"></xsl:variable>
        <xsl:variable name="y2_title" saxon:assignable="yes"></xsl:variable>
        <xsl:variable name="item_desc" saxon:assignable="yes"></xsl:variable>
        <xsl:variable name="item_colors" saxon:assignable="yes"></xsl:variable>
        <xsl:variable name="sec_ser" saxon:assignable="yes"></xsl:variable>

        <xsl:if test="string-length($auth) > 0">
           <saxon:assign name="x_data" select="$graph/Authors/Author[@name = $auth]/X"/>
           <saxon:assign name="y_data" select="$graph/Authors/Author[@name = $auth]/Y"/>

           <saxon:assign name="title" select="$graph/Authors/@title"/>
           <saxon:assign name="x_title" select="$graph/Authors/@xTitle"/>
           <saxon:assign name="y_title" select="$graph/Authors/@yTitle"/>
           <saxon:assign name="y2_title" select="$graph/Authors/@yTitle2"/>
           <saxon:assign name="sec_ser" select="$graph/Authors/@secSer"/>
        
           <xsl:for-each select="$graph/Categories/Category[string-length(@authPos) > 0]">
              <xsl:sort select="@authPos"/>
              
              <xsl:if test="string-length($item_desc) > 0"><saxon:assign name="item_desc"><xsl:value-of select="concat($item_desc,',')"/></saxon:assign></xsl:if>              
              <saxon:assign name="item_desc" select="concat($item_desc,@name)"/>
              <xsl:if test="string-length($item_colors) > 0"><saxon:assign name="item_colors"><xsl:value-of select="concat($item_colors,',')"/></saxon:assign></xsl:if>              
              <saxon:assign name="item_colors" select="concat($item_colors,@color)"/>
           </xsl:for-each>
           
        </xsl:if>
        <xsl:if test="not(string-length($auth) > 0)">
           <saxon:assign name="x_data" select="$graph/Total/X"/>
           <saxon:assign name="y_data" select="$graph/Total/Y"/>

           <saxon:assign name="title" select="$graph/Total/@title"/>
           <saxon:assign name="x_title" select="$graph/Total/@xTitle"/>
           <saxon:assign name="y_title" select="$graph/Total/@yTitle"/>
           <saxon:assign name="y2_title" select="$graph/Total/@yTitle2"/>
           <saxon:assign name="sec_ser" select="$graph/Total/@secSer"/>
        
           <xsl:for-each select="$graph/Categories/Category[string-length(@pos) > 0]">
              <xsl:sort select="@pos"/>
              
              <xsl:if test="string-length($item_desc) > 0"><saxon:assign name="item_desc"><xsl:value-of select="concat($item_desc,',')"/></saxon:assign></xsl:if>              
              <saxon:assign name="item_desc" select="concat($item_desc,@name)"/>
              <xsl:if test="string-length($item_colors) > 0"><saxon:assign name="item_colors"><xsl:value-of select="concat($item_colors,',')"/></saxon:assign></xsl:if>              
              <saxon:assign name="item_colors" select="concat($item_colors,@color)"/>
           </xsl:for-each>
           
        </xsl:if>

        <xsl:if test="string-length($sec_ser) > 0">
        
           <xsl:call-template name="graph">
              <xsl:with-param name="chart_type">daxis</xsl:with-param>
              <xsl:with-param name="y_data" select="$y_data"/>
              <xsl:with-param name="x_data" select="$x_data"/>
              <xsl:with-param name="item_desc" select="$item_desc"/>
              <xsl:with-param name="item_colors" select="$item_colors"/>
              <xsl:with-param name="title" select="$title"/>
              <xsl:with-param name="x_title" select="$x_title"/>
              <xsl:with-param name="y_title" select="$y_title"/>
              <xsl:with-param name="img_name" select="$img_name"/>
              <xsl:with-param name="y2_title" select="$y2_title"/>
              <xsl:with-param name="sec_ser" select="$sec_ser"/>
           </xsl:call-template>
        </xsl:if>
        <xsl:if test="not(string-length($sec_ser) > 0)">
        
           <xsl:call-template name="graph">
              <xsl:with-param name="chart_type">line</xsl:with-param>
              <xsl:with-param name="y_data" select="$y_data"/>
              <xsl:with-param name="x_data" select="$x_data"/>
              <xsl:with-param name="item_desc" select="$item_desc"/>
              <xsl:with-param name="item_colors" select="$item_colors"/>
              <xsl:with-param name="title" select="$title"/>
              <xsl:with-param name="x_title" select="$x_title"/>
              <xsl:with-param name="y_title" select="$y_title"/>
              <xsl:with-param name="img_name" select="$img_name"/>
           </xsl:call-template>
        </xsl:if>
    </xsl:template>

    <!-- =============== generate graph ============== -->
    
    <xsl:template name="graph">
    <xsl:param name="chart_type"/>  
    <xsl:param name="y_data"/>
    <xsl:param name="x_data"/>
    <xsl:param name="item_desc"/>
    <xsl:param name="item_colors"/>
    <xsl:param name="title"/>
    <xsl:param name="x_title"/> 
    <xsl:param name="y_title"/>
    <xsl:param name="img_name"/>
    <xsl:param name="y2_title"/>
    <xsl:param name="sec_ser"/>
    <xsl:param name="sec_start"/>
    
    <xsl:variable name="img_uri" select="concat(($output_dir),($img_name),'.jpeg')"/>
    <xsl:variable name="img_url" select="translate($img_uri, '\','/')"/>
    <xsl:variable name="img_file" select="concat(($img_name),'.jpeg')"/>
  
    <xsl:variable name="res_graph" saxon:assignable="yes"></xsl:variable>
    <!-- standard axis -->
    <xsl:if test="not(string-length($sec_ser) > 0)">
    <saxon:assign name="res_graph" 
         select="graph:generate($img_url,$chart_type,$y_data,$x_data,$item_desc,$title,$x_title,$y_title,620,220,$item_colors)"/>
    </xsl:if>   
   <!-- dual axis -->
    <xsl:if test="string-length($sec_ser) > 0 and not(string-length($sec_start) > 0)">
    <saxon:assign name="res_graph" 
         select="graph:generate($img_url,$chart_type,$y_data,$x_data,$item_desc,$title,$x_title,$y_title,$item_colors,$y2_title,$sec_ser,620,280)"/>
    </xsl:if>   
    <xsl:if test="string-length($sec_ser) > 0 and (string-length($sec_start) > 0)">
    <saxon:assign name="res_graph" 
         select="graph:generate($img_url,$chart_type,$y_data,$x_data,$item_desc,$title,$x_title,$y_title,$item_colors,$y2_title,$sec_ser,$sec_start,620,280)"/>
    </xsl:if>   

    <table width='{$width}' border='0' bordercolor='{$cs_bdrcolor}' cellpadding='2' cellspacing='0'>
        <xsl:if test="($report_format_mode='pdf')">
            <xsl:attribute name="cols">100%</xsl:attribute>
        </xsl:if>
    <tr>
    <td align="center">
    <xsl:call-template name="img_ref">
    <xsl:with-param name="src" select="($img_file)"/>   
    <xsl:with-param name="alt" select="($img_file)"/>   
    </xsl:call-template>    
    </td>
    </tr>   
    </table>
    </xsl:template>   
    
    <!-- ================= print text with associations information  ============================ -->
    <xsl:template name="associations">
        <xsl:if test="(($associations = 'true') and (count(./assoc) > 0))">
            <xsl:variable name="assocs" select="./assoc"/>
            <xsl:variable name="tags" select="/ResultsSession/AssocUrls/Tag"/>			        
            <xsl:for-each select="$tags">
                <xsl:variable name="currTag" select="@name"/>
                <xsl:variable name="assocsNumber" select="count($assocs[@tag=$currTag])" saxon:assignable="yes"/>			            
                <xsl:if test="($assocsNumber) > 0">
                    <b><xsl:value-of select="/ResultsSession/AssocUrls/Tag[@name=$currTag]/@disp"/></b> :
                    <xsl:for-each select="$assocs[@tag=$currTag]">
                        <xsl:if test="string-length(@templ) > 0">
                            <xsl:variable name="templateId" select="@templ"/>
                            <xsl:variable name="url" select="/ResultsSession/AssocUrls/Url[@id=$templateId]/@url" saxon:assignable="yes"/>
                            <xsl:if test="contains($url, '[%ID%]')">
                                <saxon:assign name="url"><xsl:value-of select="substring-before($url,'[%ID%]')"/><xsl:value-of select="@id"/><xsl:value-of select="substring-after($url,'[%ID%]')"/></saxon:assign>
                            </xsl:if>
                            <xsl:if test="contains($url, '${id}')">
                                <saxon:assign name="url"><xsl:value-of select="substring-before($url,'${id}')"/><xsl:value-of select="@id"/><xsl:value-of select="substring-after($url,'${id}')"/></saxon:assign>
                            </xsl:if>
                            <a href="{$url}" class="red_link" target="_blank"><xsl:value-of select="@id"/></a>
                        </xsl:if>
                        <xsl:if test="string-length(@templ) = 0">
                            <xsl:value-of select="@id"/>                            
                        </xsl:if>
                        <xsl:if test="$assocsNumber > 1">, </xsl:if>
                        <saxon:assign name="assocsNumber" select="$assocsNumber - 1" />                        
                    </xsl:for-each>
                    <br/>
                </xsl:if>			            
            </xsl:for-each>			        			   	
        </xsl:if>            
    </xsl:template>
    
    <xsl:template name="associations_line">
        <xsl:if test="(($associations = 'true') and (count(./assoc) > 0))">
            <xsl:variable name="assocs" select="./assoc"/>
            <xsl:variable name="tags" select="/ResultsSession/AssocUrls/Tag"/>			        
            <xsl:for-each select="$tags">
                <xsl:variable name="currTag" select="@name"/>
                <xsl:variable name="assocsNumber" select="count($assocs[@tag=$currTag])" saxon:assignable="yes"/>			            
                <xsl:if test="($assocsNumber) > 0">
                    <xsl:value-of select="/ResultsSession/AssocUrls/Tag[@name=$currTag]/@disp"/> :
                    <xsl:for-each select="$assocs[@tag=$currTag]">
                        <xsl:if test="string-length(@templ) > 0">
                            <xsl:variable name="templateId" select="@templ"/>
                            <xsl:variable name="url" select="/ResultsSession/AssocUrls/Url[@id=$templateId]/@url" saxon:assignable="yes"/>
                            <xsl:if test="contains($url, '[%ID%]')">
                                <saxon:assign name="url"><xsl:value-of select="substring-before($url,'[%ID%]')"/><xsl:value-of select="@id"/><xsl:value-of select="substring-after($url,'[%ID%]')"/></saxon:assign>
                            </xsl:if>
                            <xsl:if test="contains($url, '${id}')">
                                <saxon:assign name="url"><xsl:value-of select="substring-before($url,'${id}')"/><xsl:value-of select="@id"/><xsl:value-of select="substring-after($url,'${id}')"/></saxon:assign>
                            </xsl:if>
                            <a href="{$url}" class="red_link" target="_blank"><xsl:value-of select="@id"/></a>
                        </xsl:if>
                        <xsl:if test="string-length(@templ) = 0">
                            <xsl:value-of select="@id"/>                            
                        </xsl:if>
                        <xsl:if test="$assocsNumber > 1">, </xsl:if>
                        <saxon:assign name="assocsNumber" select="$assocsNumber - 1" />                        
                    </xsl:for-each>
                    <xsl:value-of select="($nbsp)" disable-output-escaping="yes"/>
                </xsl:if>			            
            </xsl:for-each>			        			   	
        </xsl:if>            
    </xsl:template>
        
    
</xsl:stylesheet>
